

-- Generated by Relational Schema Center on Sun Aug 29 19:17:20 EDT 2004 for Cloudscape V5.1


CREATE SCHEMA AUCTION;

CREATE TABLE AUCTION.REGISTRATION
  (USERID INTEGER NOT NULL,
   EMAIL VARCHAR(100) NOT NULL,
   PASSWD CHAR(10) NOT NULL,
   NAME VARCHAR(100) NOT NULL,
   CARDTYPE VARCHAR(20) NULL,
   ACCTNUM VARCHAR(16) NULL,
   EXPIRY TIMESTAMP NULL,
   BILLINGADDRESS INTEGER NOT NULL,
   SHIPPINGADDRESS INTEGER NOT NULL,
   SHIPPINGSAME INTEGER NOT NULL DEFAULT 1,
   ACTIVE INTEGER NOT NULL,
   RANK INTEGER NOT NULL);

ALTER TABLE AUCTION.REGISTRATION
  ADD CONSTRAINT PK_REGISTRATION PRIMARY KEY (USERID);

CREATE TABLE AUCTION.ADDRESS
  (ADDRESSID INTEGER NOT NULL,
   STREET VARCHAR(50) NOT NULL,
   CITY VARCHAR(50) NOT NULL,
   STATE INTEGER NOT NULL,
   ZIP VARCHAR(8) NOT NULL,
   PHONENUM VARCHAR(18) NOT NULL);

ALTER TABLE AUCTION.ADDRESS
  ADD CONSTRAINT PK_ADDRESS PRIMARY KEY (ADDRESSID);

CREATE TABLE AUCTION.STATES
  (STATEID INTEGER NOT NULL,
   SHORTNAME CHAR(2) NULL,
   FULLNAME VARCHAR(40) NULL);

ALTER TABLE AUCTION.STATES
  ADD CONSTRAINT PK_STATES PRIMARY KEY (STATEID);

CREATE TABLE AUCTION.ACCOUNTSPAYABLE
  (APID INTEGER NOT NULL,
   USERID INTEGER NULL,
   TRANSACTIONID INTEGER NULL,
   CHECKNUMBER INTEGER NULL,
   AMOUNT INTEGER NULL);

ALTER TABLE AUCTION.ACCOUNTSPAYABLE
  ADD CONSTRAINT PK_PAYABLE PRIMARY KEY (APID);

CREATE TABLE AUCTION.BID
  (BIDID INTEGER NOT NULL,
   USERID INTEGER NOT NULL,
   ITEMTYPEID INTEGER NOT NULL,
   CURRENTBID INTEGER NOT NULL,
   MAXIMUMBID INTEGER NULL,
   BIDINCREMENT INTEGER NULL);

ALTER TABLE AUCTION.BID
  ADD CONSTRAINT "c0f7802d-00fe-9b85-6dbc-0000001652c0" PRIMARY KEY (BIDID);

CREATE TABLE AUCTION.ITEM
  (ITEMTYPEID INTEGER NOT NULL,
   CATALOGNUMBER INTEGER NULL,
   TITLE VARCHAR(75) NULL,
   DESCRIPTION VARCHAR(2000) NULL,
   VALUE INTEGER NULL,
   STARTINGBID INTEGER NULL,
   IMAGEPATH VARCHAR(200) NULL,
   IMAGESMALLPATH VARCHAR(200) NULL,
   LASTBID INTEGER NULL,
   LASTBIDDER INTEGER NULL,
   STARTBIDDING TIMESTAMP NULL,
   ENDBIDDING TIMESTAMP NULL,
   STATUS INTEGER NOT NULL);

ALTER TABLE AUCTION.ITEM
  ADD CONSTRAINT "e8afc026-00fe-9b85-6dbc-0000001652c0" PRIMARY KEY (ITEMTYPEID);

CREATE TABLE AUCTION.STATUS
  (STATUSID INTEGER NOT NULL,
   NAME VARCHAR(20) NOT NULL,
   DESCRIPTION VARCHAR(200) NOT NULL);

ALTER TABLE AUCTION.STATUS
  ADD CONSTRAINT PK_STATUS PRIMARY KEY (STATUSID);

CREATE TABLE AUCTION.SALE
  (SALEID INTEGER NOT NULL,
   SELLERID INTEGER NOT NULL,
   BUYERID INTEGER NULL,
   ITEMID INTEGER NOT NULL,
   AMOUNT INTEGER NULL,
   CREDITTRANS INTEGER NULL,
   DELIVERYORDERID VARCHAR(100) NULL,
   DELIVERED INTEGER NOT NULL DEFAULT -1,
   PAID INTEGER NOT NULL DEFAULT -1,
   DATESTARTED TIMESTAMP NOT NULL);

ALTER TABLE AUCTION.SALE
  ADD CONSTRAINT PK_SALE PRIMARY KEY (SALEID);

CREATE TABLE AUCTION.CATEGORY
  (CATID INTEGER NOT NULL,
   CATNAME VARCHAR(20) NOT NULL,
   DESCRIPTION VARCHAR(200) NOT NULL);

ALTER TABLE AUCTION.CATEGORY
  ADD CONSTRAINT PK_CATEGORY PRIMARY KEY (CATID);

CREATE TABLE AUCTION.NAMEVALUE
  (NAME CHAR(10) NOT NULL,
   IVALUE INTEGER NULL,
   SVALUE CHAR(100) NULL);

ALTER TABLE AUCTION.NAMEVALUE
  ADD CONSTRAINT PK_NAMEVALUE PRIMARY KEY (NAME);

CREATE TABLE AUCTION.ROLE
  (ROLEID INTEGER NOT NULL,
   ROLENAME VARCHAR(20) NOT NULL,
   DESCRIPTION VARCHAR(200) NOT NULL);

ALTER TABLE AUCTION.ROLE
  ADD CONSTRAINT PK_ROLE PRIMARY KEY (ROLEID);

CREATE TABLE AUCTION.USERTOROLE
  (USERID INTEGER NOT NULL,
   ROLEID INTEGER NOT NULL);

ALTER TABLE AUCTION.USERTOROLE
  ADD CONSTRAINT PK_USERTOROLE PRIMARY KEY (USERID, ROLEID);