package sample;
/**
 * @ws.sbf.session-facade
 * 	match="UserFacade"
 * 	value-objects="SellerItemSDO BidItemSDO"
 * 	queries="FindItemsByCategory FindItemsByValue FindItemsByDesc FindItemsByDescAndValOrderByVal FindItemsByDescAndValOrderByExp FindHighestBid"
 * @ws.sdo.value-object
 * 	name="BidItemSDO"
 *  read-only="true"
 * @ws.sdo.value-object
 * 	name="SellerItemSDO"
 * @ws.sbf.query 
 * 	name="FindItemsByDescAndValOrderByVal"
 * 	query="[select {$BidItemSDO} as i where i.description like ?1 and i.value <= ?2 order by i.value],[select in(i.bid) as b order by b.currentbid DESC]"
 *  read-only="true"
 * @ws.sbf.query 
 * 	name="FindItemsByDescAndValOrderByExp"
 * 	query="[select {$BidItemSDO} as i where i.description like ?1 and i.value <= ?2 order by i.endbidding],[select in(i.bid) as b order by b.currentbid DESC]"
 *  read-only="true"
 * @ws.sbf.query 
 * 	name="FindItemsByValue"
 * 	query="[select {$BidItemSDO} as i where i.value <= ?1],[select in(i.bid) as b order by b.currentbid DESC]"
 *  read-only="true"
 * @ws.sbf.query 
 * 	name="FindItemsByDesc"
 * 	query="[select {$BidItemSDO} as i where i.description like ?1],[select in(i.bid) as b order by b.currentbid DESC]"
 *  read-only="true"
 * @ws.sbf.query 
 * 	name="FindItemsByCategory"
 * 	query="[select {$SellerItemSDO} as i where i.category.catid=?1]"
 *  read-only="true"
 * @ws.sbf.query 
 * 	name="FindHighestBid"
 *  query="[select {$BidItemSDO} as i where i.itemid = ?1],[select in(i.bid) as b order by b.currentbid DESC]"
 * Bean implementation class for Enterprise Bean: Item
 */
public abstract class ItemBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public sample.ItemKey ejbCreate(java.lang.Integer itemid)
		throws javax.ejb.CreateException {
		setItemid(itemid);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(java.lang.Integer itemid)
		throws javax.ejb.CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * ejbCreate method for a CMP entity bean.
	 */
	public sample.ItemKey ejbCreate(
		java.lang.Integer itemtypeid,
		sample.StatusLocal argFk_itemstatus) throws javax.ejb.CreateException {
		setItemid(itemtypeid);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(
		java.lang.Integer itemtypeid,
		sample.StatusLocal argFk_itemstatus) throws javax.ejb.CreateException {
		setFk_itemstatus(argFk_itemstatus);
	}
	/**
	 * Get accessor for persistent attribute: itemid
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 */
	public abstract java.lang.Integer getItemid();
	/**
	 * Set accessor for persistent attribute: itemid
	 */
	public abstract void setItemid(java.lang.Integer newItemid);	
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: catalognumber
	 */
	public abstract java.lang.Integer getCatalognumber();
	/**
	 * Set accessor for persistent attribute: catalognumber
	 */
	public abstract void setCatalognumber(java.lang.Integer newCatalognumber);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: title
	 */
	public abstract java.lang.String getTitle();
	/**
	 * Set accessor for persistent attribute: title
	 */
	public abstract void setTitle(java.lang.String newTitle);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: description
	 */
	public abstract java.lang.String getDescription();
	/**
	 * Set accessor for persistent attribute: description
	 */
	public abstract void setDescription(java.lang.String newDescription);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: value
	 */
	public abstract java.lang.Integer getValue();
	/**
	 * Set accessor for persistent attribute: value
	 */
	public abstract void setValue(java.lang.Integer newValue);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: startingbid
	 */
	public abstract java.lang.Integer getStartingbid();
	/**
	 * Set accessor for persistent attribute: startingbid
	 */
	public abstract void setStartingbid(java.lang.Integer newStartingbid);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: imagepath
	 */
	public abstract java.lang.String getImagepath();
	/**
	 * Set accessor for persistent attribute: imagepath
	 */
	public abstract void setImagepath(java.lang.String newImagepath);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: imagesmallpath
	 */
	public abstract java.lang.String getImagesmallpath();
	/**
	 * Set accessor for persistent attribute: imagesmallpath
	 */
	public abstract void setImagesmallpath(java.lang.String newImagesmallpath);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: startbidding
	 */
	public abstract java.sql.Timestamp getStartbidding();
	/**
	 * Set accessor for persistent attribute: startbidding
	 */
	public abstract void setStartbidding(java.sql.Timestamp newStartbidding);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * Get accessor for persistent attribute: endbidding
	 */
	public abstract java.sql.Timestamp getEndbidding();
	/**
	 * Set accessor for persistent attribute: endbidding
	 */
	public abstract void setEndbidding(java.sql.Timestamp newEndbidding);
	/**
	 * This method was generated for supporting the relationship role named bid.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * 	target-value-object="BidSDO"
	 * 	contained="false"
	 */
	public abstract java.util.Collection getBid();
	/**
	 * This method was generated for supporting the relationship role named bid.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setBid(java.util.Collection aBid);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidItemSDO"
	 * 	target-value-object="StatusSDO"
	 * 	contained="false" 
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * 	target-value-object="StatusSDO"
	 * 	contained="false"
	 * This method was generated for supporting the relationship role named fk_itemstatus.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract sample.StatusLocal getFk_itemstatus();
	/**
	 * This method was generated for supporting the relationship role named fk_itemstatus.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setFk_itemstatus(sample.StatusLocal aFk_itemstatus);
	/**
	 * This method was generated for supporting the relationship role named sale.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getSale();
	/**
	 * This method was generated for supporting the relationship role named sale.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setSale(java.util.Collection aSale);
	/**
	 * This method was generated for supporting the relationship role named category.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * 	target-value-object="CategorySDO"
	 * 	contained="false"
	 */
	public abstract sample.CategoryLocal getCategory();
	/**
	 * This method was generated for supporting the relationship role named category.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setCategory(sample.CategoryLocal aCategory);

	/**
	 * @ws.sdo.value-object
	 * 	match="SellerItemSDO"
	 * 	target-value-object="SellerSDO"
	 * 	contained="false"
	 * This method was generated for supporting the relationship role named itemSeller.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract sample.RegistrationLocal getItemSeller();
	/**
	 * This method was generated for supporting the relationship role named itemSeller.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setItemSeller(sample.RegistrationLocal anItemSeller);
}