package sample;
/**
 * @ws.sdo.value-object
 * 	name="LiteUserSDO"
 * 	read-only="true"
 * @ws.sdo.value-object
 * 	name="BidderSDO"
 * 	read-only="true"
 * @ws.sdo.value-object
 * 	name="SellerSDO"
 * 	read-only="true"
 * @ws.sbf.session-facade
 * 	name="UserFacade"
 * 	value-objects="UserSDO LiteUserSDO BidderSDO SellerSDO"
 *  queries="FindUserByEmailPassword FindActiveUsers"
 * @ws.sdo.value-object
 * 	name="UserSDO"
 * 	read-only="false"
 * @ws.sbf.query
 *   name="FindUserByEmailPassword"
 *   query="[select {$UserSDO} as r where r.email = ?1 and r.passwd = ?2]"
 *   read-only="true"
 * @ws.sbf.query
 *   name="FindActiveUsers"
 *   query="[select {$LiteUserSDO} as r where r.active=1]"
 * Bean implementation class for Enterprise Bean: Registration
 */
public abstract class RegistrationBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public sample.RegistrationKey ejbCreate(java.lang.Integer userid)
		throws javax.ejb.CreateException {
		setUserid(userid);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(java.lang.Integer userid)
		throws javax.ejb.CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * ejbCreate method for a CMP entity bean.
	 */
	public sample.RegistrationKey ejbCreate(
		java.lang.Integer userid,
		java.lang.String email,
		java.lang.String passwd,
		java.lang.String name,
		java.lang.Integer shippingsame,
		java.lang.Integer active,
		java.lang.Integer rank,
		sample.AddressLocal argFk_shipaddress,
		sample.AddressLocal argFk_billingaddress)
		throws javax.ejb.CreateException {
		setUserid(userid);
		setEmail(email);
		setPasswd(passwd);
		setName(name);
		setShippingsame(shippingsame);
		setActive(active);
		setRank(rank);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(
		java.lang.Integer userid,
		java.lang.String email,
		java.lang.String passwd,
		java.lang.String name,
		java.lang.Integer shippingsame,
		java.lang.Integer active,
		java.lang.Integer rank,
		sample.AddressLocal argFk_shipaddress,
		sample.AddressLocal argFk_billingaddress)
		throws javax.ejb.CreateException {
		setFk_shipaddress(argFk_shipaddress);
		setFk_billingaddress(argFk_billingaddress);
	}
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * @ws.sdo.value-object
	 * 	match="BidderSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerSDO"
	 * Get accessor for persistent attribute: userid
	 */
	public abstract java.lang.Integer getUserid();
	/**
	 * Set accessor for persistent attribute: userid
	 */
	public abstract void setUserid(java.lang.Integer newUserid);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * @ws.sdo.value-object
	 * 	match="BidderSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerSDO"
	 * Get accessor for persistent attribute: email
	 */
	public abstract java.lang.String getEmail();
	/**
	 * Set accessor for persistent attribute: email
	 */
	public abstract void setEmail(java.lang.String newEmail);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * Get accessor for persistent attribute: passwd
	 */
	public abstract java.lang.String getPasswd();
	/**
	 * Set accessor for persistent attribute: passwd
	 */
	public abstract void setPasswd(java.lang.String newPasswd);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * @ws.sdo.value-object
	 * 	match="BidderSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerSDO"
	 * Get accessor for persistent attribute: name
	 */
	public abstract java.lang.String getName();
	/**
	 * Set accessor for persistent attribute: name
	 */
	public abstract void setName(java.lang.String newName);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * Get accessor for persistent attribute: cardtype
	 */
	public abstract java.lang.String getCardtype();
	/**
	 * Set accessor for persistent attribute: cardtype
	 */
	public abstract void setCardtype(java.lang.String newCardtype);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * @ws.sdo.value-object
	 * 	match="BidderSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerSDO"
	 * Get accessor for persistent attribute: acctnum
	 */
	public abstract java.lang.String getAcctnum();
	/**
	 * Set accessor for persistent attribute: acctnum
	 */
	public abstract void setAcctnum(java.lang.String newAcctnum);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * Get accessor for persistent attribute: expiry
	 */
	public abstract java.sql.Timestamp getExpiry();
	/**
	 * Set accessor for persistent attribute: expiry
	 */
	public abstract void setExpiry(java.sql.Timestamp newExpiry);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * Get accessor for persistent attribute: shippingsame
	 */
	public abstract java.lang.Integer getShippingsame();
	/**
	 * Set accessor for persistent attribute: shippingsame
	 */
	public abstract void setShippingsame(java.lang.Integer newShippingsame);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * @ws.sdo.value-object
	 * 	match="BidderSDO"
	 * @ws.sdo.value-object
	 * 	match="SellerSDO"
	 * Get accessor for persistent attribute: active
	 */
	public abstract java.lang.Integer getActive();
	/**
	 * Set accessor for persistent attribute: active
	 */
	public abstract void setActive(java.lang.Integer newActive);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * Get accessor for persistent attribute: rank
	 */
	public abstract java.lang.Integer getRank();
	/**
	 * Set accessor for persistent attribute: rank
	 */
	public abstract void setRank(java.lang.Integer newRank);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * 	target-value-object="AddressSDO"
	 * 	contained="false"
	 * This method was generated for supporting the relationship role named fk_shipaddress.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract sample.AddressLocal getFk_shipaddress();
	/**
	 * This method was generated for supporting the relationship role named fk_shipaddress.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setFk_shipaddress(sample.AddressLocal aFk_shipaddress);
	/**
	 * This method was generated for supporting the relationship role named fk_billingaddress.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract sample.AddressLocal getFk_billingaddress();
	/**
	 * This method was generated for supporting the relationship role named fk_billingaddress.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setFk_billingaddress(
		sample.AddressLocal aFk_billingaddress);
	/**
	 * @ws.sdo.value-object
	 * 	match="UserSDO"
	 * 	target-value-object="AccountsPayableSDO"
	 * 	contained="false"
	 * This method was generated for supporting the relationship role named accountspayable.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getAccountspayable();
	/**
	 * This method was generated for supporting the relationship role named accountspayable.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setAccountspayable(
		java.util.Collection anAccountspayable);
	/**
	 * @ws.sdo.value-object
	 * 	match="BidderSDO"
	 * 	target-value-object="BidSDO"
	 * 	contained="false"
	 * 	This method was generated for supporting the relationship role named bid.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getBid();
	/**
	 * This method was generated for supporting the relationship role named bid.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setBid(java.util.Collection aBid);
	/**
	 * This method was generated for supporting the relationship role named sale_1.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getSale_1();
	/**
	 * This method was generated for supporting the relationship role named sale_1.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setSale_1(java.util.Collection aSale_1);
	
	
	public abstract java.util.Collection getSellerItem();
	/**
	 * This method was generated for supporting the relationship role named sellerItem.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setSellerItem(java.util.Collection aSellerItem);

	//public abstract java.util.Collection getUsertorole();
	/**
	 * This method was generated for supporting the relationship role named sellerItem.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	//public abstract void setUsertorole(java.util.Collection aSellerItem);

}