package sample;

import java.rmi.RemoteException;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;

import sample.sdo.CategoryLiteSDO;
import sample.sdo.CategoryLiteSDORoot;
import sample.sdo.CategorySDO;
import sample.sdo.CategorySDORoot;
import sample.sdo.SdoPackage;
import sample.sdo.StatesSDO;
import sample.sdo.StatesSDORoot;
import sample.sdo.StatusSDO;
import sample.sdo.StatusSDORoot;

import com.ibm.etools.service.locator.ServiceLocatorManager;
import com.ibm.oid.util.OIDTypeMap;
import com.ibm.oiddemo.OIDGeneratorSessionLocal;
import com.ibm.oiddemo.OIDGeneratorSessionLocalHome;
import com.ibm.websphere.ejbquery.QueryException;
import com.ibm.websphere.sbf.MediatorMetaData;
import com.ibm.websphere.sbf.MediatorMetaDataCache;
import com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException;
import com.ibm.websphere.sbf.exceptions.CreateException;
import com.ibm.websphere.sbf.exceptions.DeleteException;
import com.ibm.websphere.sbf.exceptions.FindException;
import com.ibm.websphere.sbf.exceptions.MediatorMetaDataNotFoundException;
import com.ibm.websphere.sbf.exceptions.UpdateException;
import com.ibm.websphere.sdo.mediator.ejb.Mediator;
import com.ibm.websphere.sdo.mediator.ejb.MediatorFactory;
import commonj.sdo.DataGraph;
import commonj.sdo.DataObject;

/**
 * @ejb.bean
 *	jndi-name="ejb/sample/AuctionSystemFacadeHome"
 *	name="AuctionSystemFacade"
 *	view-type="both"
 *	type="Stateless"
 *  transaction-type="Container"
 *<!-- begin-user-doc -->
 * @ejb.ejb-external-ref
 *  view-type="local"
 * 	ref-name="ejb/OIDGeneratorSession"
 *  link="OIDGeneratorSession"
 *  type="Session"
 *  home="com.ibm.oiddemo.OIDGeneratorSessionLocalHome"
 *  business="com.ibm.oiddemo.OIDGeneratorSessionLocal"
 *<!-- end-user-doc -->
 * This is a system generated session bean facade source file.
 * Any modifications to the tags should be done in the 
 * primary source Entity Bean file for this facade.
 * @see CategoryBean
 */
public class AuctionSystemFacadeBean implements SessionBean {
	private javax.ejb.SessionContext mySessionCtx;

	private OIDTypeMap OID_TYPE_MAP;

	private final static String STATIC_OIDGeneratorSessionLocalHome_REF_NAME = "ejb/OIDGeneratorSession";

	private final static Class STATIC_OIDGeneratorSessionLocalHome_CLASS = OIDGeneratorSessionLocalHome.class;

	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}

	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx) {
		mySessionCtx = ctx;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbCreate()
	 */
	public void ejbCreate() throws javax.ejb.CreateException {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbRemove()
	 */
	public void ejbRemove() throws EJBException, RemoteException {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbActivate()
	 */
	public void ejbActivate() throws EJBException, RemoteException {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbPassivate()
	 */
	public void ejbPassivate() throws EJBException, RemoteException {
	}

	/**
	 * @generated
	 */
	private MediatorMetaDataCache mediatorCache = new MediatorMetaDataCache() {
		protected MediatorMetaData createMediatorMetaData(EClassifier type) {
			switch (type.getClassifierID()) {

			case SdoPackage.CATEGORY_SDO_ROOT:
				return createCategorySDORootMediatorMetaData();
			case SdoPackage.CATEGORY_LITE_SDO_ROOT:
				return createCategoryLiteSDORootMediatorMetaData();
			case SdoPackage.STATES_SDO_ROOT:
				return createStatesSDORootMediatorMetaData();
			case SdoPackage.STATUS_SDO_ROOT:
				return createStatusSDORootMediatorMetaData();

			}
			return null;
		}
	};

	private void doApplyChanges(DataObject dataObject) throws QueryException,
			MediatorMetaDataNotFoundException {
		OIDGeneratorSessionLocal anOIDGeneratorSessionLocal = createOIDGeneratorSessionLocal();

		DataGraph dg = dataObject.getDataGraph();
		if (dg != null)
			anOIDGeneratorSessionLocal.setAutoIDsIfNecessary(
					(EObject) dataObject.getDataGraph().getRootObject(),
					getOIDTypeMap());
		doApplyChangesGen(dataObject);
	}

	/**
	 * @generated
	 */
	private void doApplyChangesGen(DataObject dataObject)
			throws QueryException, MediatorMetaDataNotFoundException {
		mediatorCache.createMediator(dataObject).applyChanges(dataObject);
	}

	/**
	 * Delete a value-object.
	 * @generated
	 */
	private void doDeleteDataObject(DataObject data)
			throws MediatorMetaDataNotFoundException, QueryException {
		DataObject root = data.getDataGraph().getRootObject();
		data.delete();
		doApplyChanges(root);
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createCategorySDORootMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select c.catid, c.catname, c.description  from Category as c";
		queryStrings[1] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from in(c.item) as i";
		queryStrings[2] = "select f.statusid, f.name, f.description  from in(i.fk_itemstatus) as f";
		queryStrings[3] = "select i1.userid, i1.email, i1.name, i1.acctnum, i1.active  from in(i.itemSeller) as i1";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getCategorySDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Category", pack.getCategorySDO());
		md.addAbstractSchemaNameMapping("Item", pack.getSellerItemSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getSellerSDO());
		return md;
	}

	/**
	 * Return an array of "CategorySDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public CategorySDO[] getAllCategorySDOObjects() throws FindException {
		try {
			CategorySDORoot root = doGetCategorySDORoot(null, null);
			return root.getCategorySDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"CategorySDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "CategorySDO" value-objects.
	 */
	public CategorySDO getCategorySDOByKey(Integer primaryKey)
			throws FindException {
		return getCategorySDOByKey(new CategoryKey(primaryKey));
	}

	/**
	 * Get list of "CategorySDO" value-objects.
	 * @generated
	 */
	public CategorySDO getCategorySDOByKey(CategoryKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[4];

			queryStrings[0] = "select c.catid, c.catname, c.description  from Category as c where c.catid = ?1";
			queryStrings[1] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from in(c.item) as i";
			queryStrings[2] = "select f.statusid, f.name, f.description  from in(i.fk_itemstatus) as f";
			queryStrings[3] = "select i1.userid, i1.email, i1.name, i1.acctnum, i1.active  from in(i.itemSeller) as i1";

			Object[] pkValues = getCategorySDOPKeyObjectArray(primaryKey);

			CategorySDORoot root = doGetCategorySDORoot(queryStrings, pkValues);
			CategorySDO[] array = root.getCategorySDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"CategorySDO\" by key.", ex);
		}
	}

	/**
	 * Persist a new "CategorySDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public CategorySDO createCategorySDO(CategorySDO data)
			throws CreateException {
		createCategorySDOGen(data);
		return data;
	}

	/**
	 * Persist a new "CategorySDO" value-object.
	 * @generated
	 */
	public void createCategorySDOGen(CategorySDO data) throws CreateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating \"CategorySDO\".", ex);
		}
	}

	/**
	 * Update a "CategorySDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void updateCategorySDO(CategorySDO data) throws UpdateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new UpdateException(
					"System error while updating \"CategorySDO\".", ex);
		}
	}

	/**
	 * Delete a "CategorySDO" value-object.
	 * @generated
	 */
	public void deleteCategorySDO(CategorySDO data) throws DeleteException {
		try {
			doDeleteDataObject(data);
		} catch (Exception ex) {
			throw new DeleteException(
					"System error while deleting \"CategorySDO\".", ex);
		}
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * CategorySDORoot.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyCategorySDORootChanges(CategorySDORoot root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"CategorySDORoot\".",
					e);
		}
	}

	/**
	 * Return a CategorySDORoot which is the root object of the query.
	 * The CategorySDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public CategorySDORoot getCategorySDORoot() throws FindException {
		try {
			return doGetCategorySDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"CategorySDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private CategorySDORoot doGetCategorySDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getCategorySDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (CategorySDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getCategorySDOPKeyObjectArray(CategoryKey primaryKey) {
		return new Object[] { primaryKey.catid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createCategoryLiteSDORootMediatorMetaData() {

		String[] queryStrings = new String[1];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select c.*  from Category as c";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack
				.getCategoryLiteSDORoot(), queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Category", pack.getCategoryLiteSDO());
		return md;
	}

	/**
	 * Return an array of "CategoryLiteSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public CategoryLiteSDO[] getAllCategoryLiteSDOObjects()
			throws FindException {
		try {
			CategoryLiteSDORoot root = doGetCategoryLiteSDORoot(null, null);
			return root.getCategoryLiteSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"CategoryLiteSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "CategoryLiteSDO" value-objects.
	 */
	public CategoryLiteSDO getCategoryLiteSDOByKey(Integer primaryKey)
			throws FindException {
		return getCategoryLiteSDOByKey(new CategoryKey(primaryKey));
	}

	/**
	 * Get list of "CategoryLiteSDO" value-objects.
	 * @generated
	 */
	public CategoryLiteSDO getCategoryLiteSDOByKey(CategoryKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[1];

			queryStrings[0] = "select c.*  from Category as c where c.catid = ?1";

			Object[] pkValues = getCategoryLiteSDOPKeyObjectArray(primaryKey);

			CategoryLiteSDORoot root = doGetCategoryLiteSDORoot(queryStrings,
					pkValues);
			CategoryLiteSDO[] array = root.getCategoryLiteSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"CategoryLiteSDO\" by key.",
					ex);
		}
	}

	/**
	 * Return a CategoryLiteSDORoot which is the root object of the query.
	 * The CategoryLiteSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public CategoryLiteSDORoot getCategoryLiteSDORoot() throws FindException {
		try {
			return doGetCategoryLiteSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"CategoryLiteSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private CategoryLiteSDORoot doGetCategoryLiteSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getCategoryLiteSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (CategoryLiteSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getCategoryLiteSDOPKeyObjectArray(CategoryKey primaryKey) {
		return new Object[] { primaryKey.catid };
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "StatesSDO" value-objects.
	 */
	public StatesSDO getStatesSDOByKey(Integer primaryKey) throws FindException {
		return getStatesSDOByKey(new StatesKey(primaryKey));
	}

	/**
	 * Persist a new "StatesSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public StatesSDO createStatesSDO(StatesSDO data) throws CreateException {
		createStatesSDOGen(data);
		return data;
	}

	/**
	 * Persist a new "StatesSDO" value-object.
	 * @generated
	 */
	public void createStatesSDOGen(StatesSDO data) throws CreateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating \"StatesSDO\".", ex);
		}
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createStatusSDORootMediatorMetaData() {

		String[] queryStrings = new String[1];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select s.statusid, s.name, s.description  from Status as s";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getStatusSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return an array of "StatusSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public StatusSDO[] getAllStatusSDOObjects() throws FindException {
		try {
			StatusSDORoot root = doGetStatusSDORoot(null, null);
			return root.getStatusSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"StatusSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "StatusSDO" value-objects.
	 */
	public StatusSDO getStatusSDOByKey(Integer primaryKey) throws FindException {
		return getStatusSDOByKey(new StatusKey(primaryKey));
	}

	/**
	 * Get list of "StatusSDO" value-objects.
	 * @generated
	 */
	public StatusSDO getStatusSDOByKey(StatusKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[1];

			queryStrings[0] = "select s.statusid, s.name, s.description  from Status as s where s.statusid = ?1";

			Object[] pkValues = getStatusSDOPKeyObjectArray(primaryKey);

			StatusSDORoot root = doGetStatusSDORoot(queryStrings, pkValues);
			StatusSDO[] array = root.getStatusSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"StatusSDO\" by key.", ex);
		}
	}

	/**
	 * Persist a new "StatusSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public StatusSDO createStatusSDO(StatusSDO data) throws CreateException {
		createStatusSDOGen(data);
		return data;
	}

	/**
	 * Persist a new "StatusSDO" value-object.
	 * @generated
	 */
	public void createStatusSDOGen(StatusSDO data) throws CreateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating \"StatusSDO\".", ex);
		}
	}

	/**
	 * Update a "StatusSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void updateStatusSDO(StatusSDO data) throws UpdateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new UpdateException(
					"System error while updating \"StatusSDO\".", ex);
		}
	}

	/**
	 * Delete a "StatusSDO" value-object.
	 * @generated
	 */
	public void deleteStatusSDO(StatusSDO data) throws DeleteException {
		try {
			doDeleteDataObject(data);
		} catch (Exception ex) {
			throw new DeleteException(
					"System error while deleting \"StatusSDO\".", ex);
		}
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * StatusSDORoot.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyStatusSDORootChanges(StatusSDORoot root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"StatusSDORoot\".",
					e);
		}
	}

	/**
	 * Return a StatusSDORoot which is the root object of the query.
	 * The StatusSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public StatusSDORoot getStatusSDORoot() throws FindException {
		try {
			return doGetStatusSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"StatusSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private StatusSDORoot doGetStatusSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getStatusSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (StatusSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getStatusSDOPKeyObjectArray(StatusKey primaryKey) {
		return new Object[] { primaryKey.statusid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createStatesSDORootMediatorMetaData() {

		String[] queryStrings = new String[1];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select s.stateid, s.shortname, s.fullname  from States as s";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getStatesSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("States", pack.getStatesSDO());
		return md;
	}

	/**
	 * Return an array of "StatesSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public StatesSDO[] getAllStatesSDOObjects() throws FindException {
		try {
			StatesSDORoot root = doGetStatesSDORoot(null, null);
			return root.getStatesSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"StatesSDO\".", ex);
		}
	}

	/**
	 * Get list of "StatesSDO" value-objects.
	 * @generated
	 */
	public StatesSDO getStatesSDOByKey(StatesKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[1];

			queryStrings[0] = "select s.stateid, s.shortname, s.fullname  from States as s where s.stateid = ?1";

			Object[] pkValues = getStatesSDOPKeyObjectArray(primaryKey);

			StatesSDORoot root = doGetStatesSDORoot(queryStrings, pkValues);
			StatesSDO[] array = root.getStatesSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"StatesSDO\" by key.", ex);
		}
	}

	/**
	 * Update a "StatesSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void updateStatesSDO(StatesSDO data) throws UpdateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new UpdateException(
					"System error while updating \"StatesSDO\".", ex);
		}
	}

	/**
	 * Delete a "StatesSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void deleteStatesSDO(StatesSDO data) throws DeleteException {
		try {
			doDeleteDataObject(data);
		} catch (Exception ex) {
			throw new DeleteException(
					"System error while deleting \"StatesSDO\".", ex);
		}
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * StatesSDORoot.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyStatesSDORootChanges(StatesSDORoot root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"StatesSDORoot\".",
					e);
		}
	}

	/**
	 * Return a StatesSDORoot which is the root object of the query.
	 * The StatesSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public StatesSDORoot getStatesSDORoot() throws FindException {
		try {
			return doGetStatesSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"StatesSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private StatesSDORoot doGetStatesSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getStatesSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (StatesSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getStatesSDOPKeyObjectArray(StatesKey primaryKey) {
		return new Object[] { primaryKey.stateid };
	}

	/**
	 * @return
	 */
	private OIDTypeMap getOIDTypeMap() {
		if (OID_TYPE_MAP == null) {
			OID_TYPE_MAP = new OIDTypeMap();
			SdoPackage pack = SdoPackage.eINSTANCE;
			OID_TYPE_MAP.addTypeEntry(pack.getAccountsPayableSDO(),
					AccountspayableLocalHome.ASN_NAME, pack
							.getAccountsPayableSDO_Apid());
			OID_TYPE_MAP.addTypeEntry(pack.getAddressSDO(),
					AddressLocalHome.ASN_NAME, pack.getAddressSDO_Addressid());
			OID_TYPE_MAP.addTypeEntry(pack.getBidSDO(), BidLocalHome.ASN_NAME,
					pack.getBidSDO_Bidid());
			OID_TYPE_MAP.addTypeEntry(pack.getSellerItemSDO(),
					ItemLocalHome.ASN_NAME, pack.getSellerItemSDO_Itemid());
			OID_TYPE_MAP.addTypeEntry(pack.getUserSDO(),
					RegistrationLocalHome.ASN_NAME, pack.getUserSDO_Userid());
			OID_TYPE_MAP.addTypeEntry(pack.getSaleSDO(),
					SaleLocalHome.ASN_NAME, pack.getSaleSDO_Saleid());
			OID_TYPE_MAP.addTypeEntry(pack.getStatusSDO(),
					StatusLocalHome.ASN_NAME, pack.getStatusSDO_Statusid());
			OID_TYPE_MAP.addTypeEntry(pack.getStatesSDO(),
					StatesLocalHome.ASN_NAME, pack.getStatesSDO_Stateid());
			OID_TYPE_MAP.addTypeEntry(pack.getCategorySDO(),
					CategoryLocalHome.ASN_NAME, pack.getCategorySDO_Catid());
		}
		return OID_TYPE_MAP;
	}

	protected OIDGeneratorSessionLocal createOIDGeneratorSessionLocal() {
		OIDGeneratorSessionLocalHome anOIDGeneratorSessionLocalHome = (OIDGeneratorSessionLocalHome) ServiceLocatorManager
				.getLocalHome(STATIC_OIDGeneratorSessionLocalHome_REF_NAME,
						STATIC_OIDGeneratorSessionLocalHome_CLASS);
		try {
			if (anOIDGeneratorSessionLocalHome != null)
				return anOIDGeneratorSessionLocalHome.create();
		} catch (javax.ejb.CreateException ce) {
			ce.printStackTrace();
		}
		return null;
	}
}
