package sample;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;

import sample.sdo.AddressSDO;
import sample.sdo.BidItemSDO;
import sample.sdo.BidItemSDORoot;
import sample.sdo.BidSDO;
import sample.sdo.BidSDORoot;
import sample.sdo.BidderSDO;
import sample.sdo.BidderSDORoot;
import sample.sdo.CategorySDO;
import sample.sdo.FindActiveUsers;
import sample.sdo.FindHighestBid;
import sample.sdo.FindItemsByCategory;
import sample.sdo.FindItemsByDesc;
import sample.sdo.FindItemsByDescAndValOrderByExp;
import sample.sdo.FindItemsByDescAndValOrderByVal;
import sample.sdo.FindItemsByValue;
import sample.sdo.FindUserByEmailPassword;
import sample.sdo.LiteUserSDO;
import sample.sdo.LiteUserSDORoot;
import sample.sdo.SdoPackage;
import sample.sdo.SellerItemSDO;
import sample.sdo.SellerItemSDORoot;
import sample.sdo.SellerSDO;
import sample.sdo.SellerSDORoot;
import sample.sdo.StatesSDO;
import sample.sdo.UserSDO;
import sample.sdo.UserSDORoot;
import sample.sdo.util.SdoClientFactory;

import com.ibm.etools.service.locator.ServiceLocatorManager;
import com.ibm.oid.util.OIDTypeMap;
import com.ibm.oiddemo.OIDGeneratorSessionLocal;
import com.ibm.oiddemo.OIDGeneratorSessionLocalHome;
import com.ibm.websphere.ejbquery.QueryException;
import com.ibm.websphere.sbf.MediatorMetaData;
import com.ibm.websphere.sbf.MediatorMetaDataCache;
import com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException;
import com.ibm.websphere.sbf.exceptions.CreateException;
import com.ibm.websphere.sbf.exceptions.DeleteException;
import com.ibm.websphere.sbf.exceptions.FindException;
import com.ibm.websphere.sbf.exceptions.MediatorMetaDataNotFoundException;
import com.ibm.websphere.sbf.exceptions.UpdateException;
import com.ibm.websphere.sdo.mediator.ejb.Mediator;
import com.ibm.websphere.sdo.mediator.ejb.MediatorFactory;
import commonj.sdo.DataGraph;
import commonj.sdo.DataObject;

/**
 * @ejb.bean
 *	jndi-name="ejb/sample/UserFacadeHome"
 *	name="UserFacade"
 *	view-type="both"
 *	type="Stateless"
 *  transaction-type="Container"
 *<!-- begin-user-doc -->
 * @ejb.ejb-ref
 * 	ejb-name="AuctionSystemFacade"
 *  view-type="local"
 * 	ref-name="ejb/AuctionSystemFacade"
 * @ejb.ejb-external-ref
 *  view-type="local"
 * 	ref-name="ejb/OIDGeneratorSession"
 *  link="OIDGeneratorSession"
 *  type="Session"
 *  home="com.ibm.oiddemo.OIDGeneratorSessionLocalHome"
 *  business="com.ibm.oiddemo.OIDGeneratorSessionLocal"
 *<!-- end-user-doc -->
 * This is a system generated session bean facade source file.
 * Any modifications to the tags should be done in the 
 * primary source Entity Bean file for this facade.
 * @see RegistrationBean
 */
public class UserFacadeBean implements SessionBean {
	private javax.ejb.SessionContext mySessionCtx;

	private OIDTypeMap OID_TYPE_MAP;

	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}

	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx) {
		mySessionCtx = ctx;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbCreate()
	 */
	public void ejbCreate() throws javax.ejb.CreateException {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbRemove()
	 */
	public void ejbRemove() throws EJBException, RemoteException {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbActivate()
	 */
	public void ejbActivate() throws EJBException, RemoteException {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.ejb.SessionBean#ejbPassivate()
	 */
	public void ejbPassivate() throws EJBException, RemoteException {
	}

	/**
	 * @generated
	 */
	private MediatorMetaDataCache mediatorCache = new MediatorMetaDataCache() {
		protected MediatorMetaData createMediatorMetaData(EClassifier type) {
			switch (type.getClassifierID()) {

			case SdoPackage.USER_SDO_ROOT:
				return createUserSDORootMediatorMetaData();
			case SdoPackage.LITE_USER_SDO_ROOT:
				return createLiteUserSDORootMediatorMetaData();
			case SdoPackage.BIDDER_SDO_ROOT:
				return createBidderSDORootMediatorMetaData();
			case SdoPackage.SELLER_SDO_ROOT:
				return createSellerSDORootMediatorMetaData();
			case SdoPackage.BID_SDO_ROOT:
				return createBidSDORootMediatorMetaData();
			case SdoPackage.SELLER_ITEM_SDO_ROOT:
				return createSellerItemSDORootMediatorMetaData();
			case SdoPackage.BID_ITEM_SDO_ROOT:
				return createBidItemSDORootMediatorMetaData();

			case SdoPackage.FIND_USER_BY_EMAIL_PASSWORD:
				return createFindUserByEmailPasswordMediatorMetaData();

			case SdoPackage.FIND_ACTIVE_USERS:
				return createFindActiveUsersMediatorMetaData();

			case SdoPackage.FIND_ITEMS_BY_CATEGORY:
				return createFindItemsByCategoryMediatorMetaData();

			case SdoPackage.FIND_ITEMS_BY_VALUE:
				return createFindItemsByValueMediatorMetaData();

			case SdoPackage.FIND_ITEMS_BY_DESC:
				return createFindItemsByDescMediatorMetaData();

			case SdoPackage.FIND_ITEMS_BY_DESC_AND_VAL_ORDER_BY_VAL:
				return createFindItemsByDescAndValOrderByValMediatorMetaData();

			case SdoPackage.FIND_ITEMS_BY_DESC_AND_VAL_ORDER_BY_EXP:
				return createFindItemsByDescAndValOrderByExpMediatorMetaData();

			case SdoPackage.FIND_HIGHEST_BID:
				return createFindHighestBidMediatorMetaData();

			}
			return null;
		}
	};

	private final static String STATIC_OIDGeneratorSessionLocalHome_REF_NAME = "ejb/OIDGeneratorSession";

	private final static Class STATIC_OIDGeneratorSessionLocalHome_CLASS = OIDGeneratorSessionLocalHome.class;

	private final static String STATIC_AuctionSystemFacadeLocalHome_REF_NAME = "ejb/AuctionSystemFacade";

	private final static Class STATIC_AuctionSystemFacadeLocalHome_CLASS = AuctionSystemFacadeLocalHome.class;

	/**
	 *
	 */
	private void doApplyChanges(DataObject dataObject) throws QueryException,
			MediatorMetaDataNotFoundException {
		OIDGeneratorSessionLocal anOIDGeneratorSessionLocal = createOIDGeneratorSessionLocal();
		DataGraph dg = dataObject.getDataGraph();
		if (dg != null)
			anOIDGeneratorSessionLocal.setAutoIDsIfNecessary(
					(EObject) dataObject.getDataGraph().getRootObject(),
					getOIDTypeMap());
		doApplyChangesGen(dataObject);
	}

	/**
	 * @generated
	 */
	private void doApplyChangesGen(DataObject dataObject)
			throws QueryException, MediatorMetaDataNotFoundException {
		mediatorCache.createMediator(dataObject).applyChanges(dataObject);
	}

	/**
	 * Delete a value-object.
	 * @generated
	 */
	private void doDeleteDataObject(DataObject data)
			throws MediatorMetaDataNotFoundException, QueryException {
		DataObject root = data.getDataGraph().getRootObject();
		data.delete();
		doApplyChanges(root);
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createUserSDORootMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select r.userid, r.email, r.passwd, r.name, r.cardtype, r.acctnum, r.expiry, r.shippingsame, r.active, r.rank  from Registration as r";
		queryStrings[1] = "select f.addressid, f.street, f.city, f.zip, f.phonenum  from in(r.fk_shipaddress) as f";
		queryStrings[2] = "select f1.stateid, f1.shortname, f1.fullname  from in(f.fk_state) as f1";
		queryStrings[3] = "select a.apid, a.transactionid, a.checknumber, a.amount  from in(r.accountspayable) as a";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getUserSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Registration", pack.getUserSDO());
		md.addAbstractSchemaNameMapping("Address", pack.getAddressSDO());
		md.addAbstractSchemaNameMapping("States", pack.getStatesSDO());
		md.addAbstractSchemaNameMapping("Accountspayable", pack
				.getAccountsPayableSDO());
		return md;
	}

	/**
	 * Return an array of "UserSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public UserSDO[] getAllUserSDOObjects() throws FindException {
		try {
			UserSDORoot root = doGetUserSDORoot(null, null);
			return root.getUserSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"UserSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "UserSDO" value-objects.
	 */
	public UserSDO getUserSDOByKey(Integer primaryKey) throws FindException {
		return getUserSDOByKey(new RegistrationKey(primaryKey));
	}

	/**
	 * Get list of "UserSDO" value-objects.
	 * @generated
	 */
	public UserSDO getUserSDOByKey(RegistrationKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[4];

			queryStrings[0] = "select r.userid, r.email, r.passwd, r.name, r.cardtype, r.acctnum, r.expiry, r.shippingsame, r.active, r.rank  from Registration as r where r.userid = ?1";
			queryStrings[1] = "select f.addressid, f.street, f.city, f.zip, f.phonenum  from in(r.fk_shipaddress) as f";
			queryStrings[2] = "select f1.stateid, f1.shortname, f1.fullname  from in(f.fk_state) as f1";
			queryStrings[3] = "select a.apid, a.transactionid, a.checknumber, a.amount  from in(r.accountspayable) as a";

			Object[] pkValues = getUserSDOPKeyObjectArray(primaryKey);

			UserSDORoot root = doGetUserSDORoot(queryStrings, pkValues);
			UserSDO[] array = root.getUserSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"UserSDO\" by key.", ex);
		}
	}

	/**
	 * Persist a new "UserSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public UserSDO createUserSDO(UserSDO data) throws CreateException {
		createUserSDOGen(data);
		return data;
	}

	/**
	 * Persist a new "UserSDO" value-object.
	 * @generated
	 */
	public void createUserSDOGen(UserSDO data) throws CreateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating \"UserSDO\".", ex);
		}
	}

	/**
	 * Update a "UserSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void updateUserSDO(UserSDO data) throws UpdateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new UpdateException(
					"System error while updating \"UserSDO\".", ex);
		}
	}

	/**
	 * Delete a "UserSDO" value-object.
	 * @generated
	 */
	public void deleteUserSDO(UserSDO data) throws DeleteException {
		try {
			doDeleteDataObject(data);
		} catch (Exception ex) {
			throw new DeleteException(
					"System error while deleting \"UserSDO\".", ex);
		}
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * UserSDORoot.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyUserSDORootChanges(UserSDORoot root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"UserSDORoot\".",
					e);
		}
	}

	/**
	 * Return a UserSDORoot which is the root object of the query.
	 * The UserSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public UserSDORoot getUserSDORoot() throws FindException {
		try {
			return doGetUserSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"UserSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private UserSDORoot doGetUserSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getUserSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (UserSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getUserSDOPKeyObjectArray(RegistrationKey primaryKey) {
		return new Object[] { primaryKey.userid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createLiteUserSDORootMediatorMetaData() {

		String[] queryStrings = new String[1];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select r.*  from Registration as r";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getLiteUserSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Registration", pack.getLiteUserSDO());
		return md;
	}

	/**
	 * Return an array of "LiteUserSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public LiteUserSDO[] getAllLiteUserSDOObjects() throws FindException {
		try {
			LiteUserSDORoot root = doGetLiteUserSDORoot(null, null);
			return root.getLiteUserSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"LiteUserSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "LiteUserSDO" value-objects.
	 */
	public LiteUserSDO getLiteUserSDOByKey(Integer primaryKey)
			throws FindException {
		return getLiteUserSDOByKey(new RegistrationKey(primaryKey));
	}

	/**
	 * Get list of "LiteUserSDO" value-objects.
	 * @generated
	 */
	public LiteUserSDO getLiteUserSDOByKey(RegistrationKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[1];

			queryStrings[0] = "select r.*  from Registration as r where r.userid = ?1";

			Object[] pkValues = getLiteUserSDOPKeyObjectArray(primaryKey);

			LiteUserSDORoot root = doGetLiteUserSDORoot(queryStrings, pkValues);
			LiteUserSDO[] array = root.getLiteUserSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"LiteUserSDO\" by key.", ex);
		}
	}

	/**
	 * Return a LiteUserSDORoot which is the root object of the query.
	 * The LiteUserSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public LiteUserSDORoot getLiteUserSDORoot() throws FindException {
		try {
			return doGetLiteUserSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"LiteUserSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private LiteUserSDORoot doGetLiteUserSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getLiteUserSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (LiteUserSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getLiteUserSDOPKeyObjectArray(RegistrationKey primaryKey) {
		return new Object[] { primaryKey.userid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createBidderSDORootMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select r.userid, r.email, r.name, r.acctnum, r.active  from Registration as r";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(r.bid) as b";
		queryStrings[2] = "select f.itemid, f.catalognumber, f.title, f.description, f.value, f.startingbid, f.imagepath, f.imagesmallpath, f.startbidding, f.endbidding  from in(b.fk_itemid) as f";
		queryStrings[3] = "select f1.statusid, f1.name, f1.description  from in(f.fk_itemstatus) as f1";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getBidderSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return an array of "BidderSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public BidderSDO[] getAllBidderSDOObjects() throws FindException {
		try {
			BidderSDORoot root = doGetBidderSDORoot(null, null);
			return root.getBidderSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"BidderSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "BidSDO" value-objects.
	 */
	public BidSDO getBidSDOByKey(Integer primaryKey) throws FindException {
		return getBidSDOByKey(new BidKey(primaryKey));
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "BidderSDO" value-objects.
	 */
	public BidderSDO getBidderSDOByKey(Integer primaryKey) throws FindException {
		return getBidderSDOByKey(new RegistrationKey(primaryKey));
	}

	/**
	 * Get list of "BidderSDO" value-objects.
	 * @generated
	 */
	public BidderSDO getBidderSDOByKey(RegistrationKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[4];

			queryStrings[0] = "select r.userid, r.email, r.name, r.acctnum, r.active  from Registration as r where r.userid = ?1";
			queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(r.bid) as b";
			queryStrings[2] = "select f.itemid, f.catalognumber, f.title, f.description, f.value, f.startingbid, f.imagepath, f.imagesmallpath, f.startbidding, f.endbidding  from in(b.fk_itemid) as f";
			queryStrings[3] = "select f1.statusid, f1.name, f1.description  from in(f.fk_itemstatus) as f1";

			Object[] pkValues = getBidderSDOPKeyObjectArray(primaryKey);

			BidderSDORoot root = doGetBidderSDORoot(queryStrings, pkValues);
			BidderSDO[] array = root.getBidderSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"BidderSDO\" by key.", ex);
		}
	}

	/**
	 * Return a BidderSDORoot which is the root object of the query.
	 * The BidderSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public BidderSDORoot getBidderSDORoot() throws FindException {
		try {
			return doGetBidderSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"BidderSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private BidderSDORoot doGetBidderSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getBidderSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (BidderSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getBidderSDOPKeyObjectArray(RegistrationKey primaryKey) {
		return new Object[] { primaryKey.userid };
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createSellerSDORootMediatorMetaData() {

		String[] queryStrings = new String[1];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select r.userid, r.email, r.name, r.acctnum, r.active  from Registration as r";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getSellerSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Registration", pack.getSellerSDO());
		return md;
	}

	/**
	 * Return an array of "SellerSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public SellerSDO[] getAllSellerSDOObjects() throws FindException {
		try {
			SellerSDORoot root = doGetSellerSDORoot(null, null);
			return root.getSellerSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"SellerSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method 
	 *  view-type="both"
	 * Get list of "SellerSDO" value-objects.
	 */
	public SellerSDO getSellerSDOByKey(Integer primaryKey) throws FindException {
		return getSellerSDOByKeyGen(new RegistrationKey(primaryKey));
	}

	/**
	 * Get list of "SellerSDO" value-objects.
	 * @generated
	 */
	public SellerSDO getSellerSDOByKeyGen(RegistrationKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[1];

			queryStrings[0] = "select r.userid, r.email, r.name, r.acctnum, r.active  from Registration as r where r.userid = ?1";

			Object[] pkValues = getSellerSDOPKeyObjectArray(primaryKey);

			SellerSDORoot root = doGetSellerSDORoot(queryStrings, pkValues);
			SellerSDO[] array = root.getSellerSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"SellerSDO\" by key.", ex);
		}
	}

	/**
	 * Return a SellerSDORoot which is the root object of the query.
	 * The SellerSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public SellerSDORoot getSellerSDORoot() throws FindException {
		try {
			return doGetSellerSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"SellerSDORoot\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */
	private SellerSDORoot doGetSellerSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getSellerSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (SellerSDORoot) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private Object[] getSellerSDOPKeyObjectArray(RegistrationKey primaryKey) {
		return new Object[] { primaryKey.userid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createBidSDORootMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from Bid as b";
		queryStrings[1] = "select f.userid, f.email, f.name, f.acctnum, f.active  from in(b.fk_bidderid) as f";
		queryStrings[2] = "select f1.itemid, f1.catalognumber, f1.title, f1.description, f1.value, f1.startingbid, f1.imagepath, f1.imagesmallpath, f1.startbidding, f1.endbidding  from in(b.fk_itemid) as f1";
		queryStrings[3] = "select f2.statusid, f2.name, f2.description  from in(f1.fk_itemstatus) as f2";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getBidSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return an array of "BidSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public BidSDO[] getAllBidSDOObjects() throws FindException {
		try {
			BidSDORoot root = doGetBidSDORoot(null, null);
			return root.getBidSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"BidSDO\".", ex);
		}
	}

	/**
	 * Get list of "BidSDO" value-objects.
	 * @generated
	 */
	public BidSDO getBidSDOByKey(BidKey primaryKey) throws FindException {
		try {

			String[] queryStrings = new String[4];

			queryStrings[0] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from Bid as b where b.bidid = ?1";
			queryStrings[1] = "select f.userid, f.email, f.name, f.acctnum, f.active  from in(b.fk_bidderid) as f";
			queryStrings[2] = "select f1.itemid, f1.catalognumber, f1.title, f1.description, f1.value, f1.startingbid, f1.imagepath, f1.imagesmallpath, f1.startbidding, f1.endbidding  from in(b.fk_itemid) as f1";
			queryStrings[3] = "select f2.statusid, f2.name, f2.description  from in(f1.fk_itemstatus) as f2";

			Object[] pkValues = getBidSDOPKeyObjectArray(primaryKey);

			BidSDORoot root = doGetBidSDORoot(queryStrings, pkValues);
			BidSDO[] array = root.getBidSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"BidSDO\" by key.", ex);
		}
	}

	/**
	 * Persist a new "BidSDO" value-object.
	 * @generated
	 */
	public void createBidSDO(BidSDO data) throws CreateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating \"BidSDO\".", ex);
		}
	}

	/**
	 * Update a "BidSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void updateBidSDO(BidSDO data) throws UpdateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new UpdateException(
					"System error while updating \"BidSDO\".", ex);
		}
	}

	/**
	 * Delete a "BidSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void deleteBidSDO(BidSDO data) throws DeleteException {
		try {
			doDeleteDataObject(data);
		} catch (Exception ex) {
			throw new DeleteException(
					"System error while deleting \"BidSDO\".", ex);
		}
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * BidSDORoot.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyBidSDORootChanges(BidSDORoot root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"BidSDORoot\".", e);
		}
	}

	/**
	 * Return a BidSDORoot which is the root object of the query.
	 * The BidSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public BidSDORoot getBidSDORoot() throws FindException {
		try {
			return doGetBidSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"BidSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private BidSDORoot doGetBidSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getBidSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (BidSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getBidSDOPKeyObjectArray(BidKey primaryKey) {
		return new Object[] { primaryKey.bidid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createSellerItemSDORootMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i";
		queryStrings[1] = "select f.statusid, f.name, f.description  from in(i.fk_itemstatus) as f";
		queryStrings[2] = "select c.catid, c.catname, c.description  from in(i.category) as c";
		queryStrings[3] = "select i1.userid, i1.email, i1.name, i1.acctnum, i1.active  from in(i.itemSeller) as i1";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getSellerItemSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getSellerItemSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		md.addAbstractSchemaNameMapping("Category", pack.getCategorySDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getSellerSDO());
		return md;
	}

	/**
	 * Return an array of "SellerItemSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public SellerItemSDO[] getAllSellerItemSDOObjects() throws FindException {
		try {
			SellerItemSDORoot root = doGetSellerItemSDORoot(null, null);
			return root.getSellerItemSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"SellerItemSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "SellerItemSDO" value-objects.
	 */
	public SellerItemSDO getSellerItemSDOByKey(Integer primaryKey)
			throws FindException {
		return getSellerItemSDOByKey(new ItemKey(primaryKey));
	}

	/**
	 * Get list of "SellerItemSDO" value-objects.
	 * @generated
	 */
	public SellerItemSDO getSellerItemSDOByKey(ItemKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[4];

			queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.itemid = ?1";
			queryStrings[1] = "select f.statusid, f.name, f.description  from in(i.fk_itemstatus) as f";
			queryStrings[2] = "select c.catid, c.catname, c.description  from in(i.category) as c";
			queryStrings[3] = "select i1.userid, i1.email, i1.name, i1.acctnum, i1.active  from in(i.itemSeller) as i1";

			Object[] pkValues = getSellerItemSDOPKeyObjectArray(primaryKey);

			SellerItemSDORoot root = doGetSellerItemSDORoot(queryStrings,
					pkValues);
			SellerItemSDO[] array = root.getSellerItemSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"SellerItemSDO\" by key.", ex);
		}
	}

	/**
	 * Persist a new "UserSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public SellerItemSDO createSellerItemSDO(SellerItemSDO data)
			throws CreateException {
		createSellerItemSDOGen(data);
		return data;
	}

	/**
	 * Persist a new "SellerItemSDO" value-object.
	 * @generated
	 */
	public void createSellerItemSDOGen(SellerItemSDO data)
			throws CreateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating \"SellerItemSDO\".", ex);
		}
	}

	/**
	 * Update a "SellerItemSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void updateSellerItemSDO(SellerItemSDO data) throws UpdateException {
		try {
			doApplyChanges(data);
		} catch (Exception ex) {
			throw new UpdateException(
					"System error while updating \"SellerItemSDO\".", ex);
		}
	}

	/**
	 * Delete a "SellerItemSDO" value-object.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void deleteSellerItemSDO(SellerItemSDO data) throws DeleteException {
		try {
			doDeleteDataObject(data);
		} catch (Exception ex) {
			throw new DeleteException(
					"System error while deleting \"SellerItemSDO\".", ex);
		}
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * SellerItemSDORoot.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applySellerItemSDORootChanges(SellerItemSDORoot root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"SellerItemSDORoot\".",
					e);
		}
	}

	/**
	 * Return a SellerItemSDORoot which is the root object of the query.
	 * The SellerItemSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public SellerItemSDORoot getSellerItemSDORoot() throws FindException {
		try {
			return doGetSellerItemSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"SellerItemSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private SellerItemSDORoot doGetSellerItemSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getSellerItemSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (SellerItemSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getSellerItemSDOPKeyObjectArray(ItemKey primaryKey) {
		return new Object[] { primaryKey.itemid };
	}

	/**
	 * @generated
	 */
	private MediatorMetaData createBidItemSDORootMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b";
		queryStrings[2] = "select f.userid, f.email, f.name, f.acctnum, f.active  from in(b.fk_bidderid) as f";
		queryStrings[3] = "select f1.statusid, f1.name, f1.description  from in(i.fk_itemstatus) as f1";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getBidItemSDORoot(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return an array of "BidItemSDO" value-objects from the database.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public BidItemSDO[] getAllBidItemSDOObjects() throws FindException {
		try {
			BidItemSDORoot root = doGetBidItemSDORoot(null, null);
			return root.getBidItemSDOAsArray();
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding all \"BidItemSDO\".", ex);
		}
	}

	/**
	 * @ejb.interface-method
	 *  view-type="both"
	 * Get list of "BidItemSDO" value-objects.
	 */
	public BidItemSDO getBidItemSDOByKey(Integer primaryKey)
			throws FindException {
		return getBidItemSDOByKey(new ItemKey(primaryKey));
	}

	/**
	 * Get list of "BidItemSDO" value-objects.
	 * @generated
	 */
	public BidItemSDO getBidItemSDOByKey(ItemKey primaryKey)
			throws FindException {
		try {

			String[] queryStrings = new String[4];

			queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.itemid = ?1";
			queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b";
			queryStrings[2] = "select f.userid, f.email, f.name, f.acctnum, f.active  from in(b.fk_bidderid) as f";
			queryStrings[3] = "select f1.statusid, f1.name, f1.description  from in(i.fk_itemstatus) as f1";

			Object[] pkValues = getBidItemSDOPKeyObjectArray(primaryKey);

			BidItemSDORoot root = doGetBidItemSDORoot(queryStrings, pkValues);
			BidItemSDO[] array = root.getBidItemSDOAsArray();
			return (array == null || array.length == 0) ? null : array[0];
		} catch (Exception ex) {
			throw new FindException(
					"System error while finding \"BidItemSDO\" by key.", ex);
		}
	}

	/**
	 * Return a BidItemSDORoot which is the root object of the query.
	 * The BidItemSDORoot object will contain references to all SDOs
	 * returned in the query.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public BidItemSDORoot getBidItemSDORoot() throws FindException {
		try {
			return doGetBidItemSDORoot(null, null);
		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"BidItemSDORoot\".",
					ex);
		}
	}

	/**
	 * @generated
	 */
	private BidItemSDORoot doGetBidItemSDORoot(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getBidItemSDORoot(), queryStringOverridesWithWhereClause,
				whereClauseValues);
		return (BidItemSDORoot) mediator.getGraph();
	}

	/**
	 * @generated
	 */
	private Object[] getBidItemSDOPKeyObjectArray(ItemKey primaryKey) {
		return new Object[] { primaryKey.itemid };
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindUserByEmailPasswordMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select r.userid, r.email, r.passwd, r.name, r.cardtype, r.acctnum, r.expiry, r.shippingsame, r.active, r.rank  from Registration as r where r.email = ?1 and r.passwd = ?2";
		queryStrings[1] = "select a.addressid, a.street, a.city, a.zip, a.phonenum  from in(r.fk_shipaddress) as a ";
		queryStrings[2] = "select s.stateid, s.shortname, s.fullname  from in(a.fk_state) as s ";
		queryStrings[3] = "select a1.apid, a1.transactionid, a1.checknumber, a1.amount  from in(r.accountspayable) as a1 ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack
				.getFindUserByEmailPassword(), queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Registration", pack.getUserSDO());
		md.addAbstractSchemaNameMapping("Address", pack.getAddressSDO());
		md.addAbstractSchemaNameMapping("States", pack.getStatesSDO());
		md.addAbstractSchemaNameMapping("Accountspayable", pack
				.getAccountsPayableSDO());
		return md;
	}

	/**
	 * Return a FindUserByEmailPassword which is the root object of the query.
	 * The FindUserByEmailPassword object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindUserByEmailPassword getFindUserByEmailPassword(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindUserByEmailPassword(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindUserByEmailPassword\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindUserByEmailPassword doGetFindUserByEmailPassword(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindUserByEmailPassword(),
				queryStringOverridesWithWhereClause, whereClauseValues);

		return (FindUserByEmailPassword) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindActiveUsersMediatorMetaData() {

		String[] queryStrings = new String[1];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select r.*  from Registration as r where r.active=1";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getFindActiveUsers(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Registration", pack.getLiteUserSDO());
		return md;
	}

	/**
	 * Return a FindActiveUsers which is the root object of the query.
	 * The FindActiveUsers object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindActiveUsers getFindActiveUsersGen(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindActiveUsers(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindActiveUsers\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindActiveUsers doGetFindActiveUsers(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindActiveUsers(), queryStringOverridesWithWhereClause,
				whereClauseValues);

		return (FindActiveUsers) mediator.getGraph();
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * FindActiveUsers.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyFindActiveUsersChanges(FindActiveUsers root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"FindActiveUsers\".",
					e);
		}
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindItemsByCategoryMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.category.catid=?1";
		queryStrings[1] = "select s.statusid, s.name, s.description  from in(i.fk_itemstatus) as s ";
		queryStrings[2] = "select c.catid, c.catname, c.description  from in(i.category) as c ";
		queryStrings[3] = "select s1.userid, s1.email, s1.name, s1.acctnum, s1.active  from in(i.itemSeller) as s1 ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack
				.getFindItemsByCategory(), queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getSellerItemSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		md.addAbstractSchemaNameMapping("Category", pack.getCategorySDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getSellerSDO());
		return md;
	}

	/**
	 * Return a FindItemsByCategory which is the root object of the query.
	 * The FindItemsByCategory object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindItemsByCategory getFindItemsByCategory(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindItemsByCategory(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindItemsByCategory\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindItemsByCategory doGetFindItemsByCategory(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindItemsByCategory(), queryStringOverridesWithWhereClause,
				whereClauseValues);

		return (FindItemsByCategory) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindItemsByValueMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.value <= ?1";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b order by b.currentbid DESC";
		queryStrings[2] = "select b1.userid, b1.email, b1.name, b1.acctnum, b1.active  from in(b.fk_bidderid) as b1 ";
		queryStrings[3] = "select s.statusid, s.name, s.description  from in(i.fk_itemstatus) as s ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getFindItemsByValue(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return a FindItemsByValue which is the root object of the query.
	 * The FindItemsByValue object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindItemsByValue getFindItemsByValue(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindItemsByValue(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindItemsByValue\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindItemsByValue doGetFindItemsByValue(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindItemsByValue(), queryStringOverridesWithWhereClause,
				whereClauseValues);

		return (FindItemsByValue) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindItemsByDescMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.description like ?1";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b order by b.currentbid DESC";
		queryStrings[2] = "select b1.userid, b1.email, b1.name, b1.acctnum, b1.active  from in(b.fk_bidderid) as b1 ";
		queryStrings[3] = "select s.statusid, s.name, s.description  from in(i.fk_itemstatus) as s ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getFindItemsByDesc(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return a FindItemsByDesc which is the root object of the query.
	 * The FindItemsByDesc object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindItemsByDesc getFindItemsByDesc(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindItemsByDesc(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindItemsByDesc\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindItemsByDesc doGetFindItemsByDesc(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindItemsByDesc(), queryStringOverridesWithWhereClause,
				whereClauseValues);

		return (FindItemsByDesc) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindItemsByDescAndValOrderByValMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.description like ?1 and i.value <= ?2 order by i.value";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b order by b.currentbid DESC";
		queryStrings[2] = "select b1.userid, b1.email, b1.name, b1.acctnum, b1.active  from in(b.fk_bidderid) as b1 ";
		queryStrings[3] = "select s.statusid, s.name, s.description  from in(i.fk_itemstatus) as s ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack
				.getFindItemsByDescAndValOrderByVal(), queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return a FindItemsByDescAndValOrderByVal which is the root object of the query.
	 * The FindItemsByDescAndValOrderByVal object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindItemsByDescAndValOrderByVal getFindItemsByDescAndValOrderByVal(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindItemsByDescAndValOrderByVal(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindItemsByDescAndValOrderByVal\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindItemsByDescAndValOrderByVal doGetFindItemsByDescAndValOrderByVal(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindItemsByDescAndValOrderByVal(),
				queryStringOverridesWithWhereClause, whereClauseValues);

		return (FindItemsByDescAndValOrderByVal) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindItemsByDescAndValOrderByExpMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.description like ?1 and i.value <= ?2 order by i.endbidding";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b order by b.currentbid DESC";
		queryStrings[2] = "select b1.userid, b1.email, b1.name, b1.acctnum, b1.active  from in(b.fk_bidderid) as b1 ";
		queryStrings[3] = "select s.statusid, s.name, s.description  from in(i.fk_itemstatus) as s ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack
				.getFindItemsByDescAndValOrderByExp(), queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return a FindItemsByDescAndValOrderByExp which is the root object of the query.
	 * The FindItemsByDescAndValOrderByExp object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindItemsByDescAndValOrderByExp getFindItemsByDescAndValOrderByExp(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindItemsByDescAndValOrderByExp(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindItemsByDescAndValOrderByExp\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindItemsByDescAndValOrderByExp doGetFindItemsByDescAndValOrderByExp(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindItemsByDescAndValOrderByExp(),
				queryStringOverridesWithWhereClause, whereClauseValues);

		return (FindItemsByDescAndValOrderByExp) mediator.getGraph();
	}

	/** 
	 * @generated 
	 */
	private MediatorMetaData createFindHighestBidMediatorMetaData() {

		String[] queryStrings = new String[4];

		int pattern = MediatorFactory.ROOT_CONTAINS_ALL;

		queryStrings[0] = "select i.itemid, i.catalognumber, i.title, i.description, i.value, i.startingbid, i.imagepath, i.imagesmallpath, i.startbidding, i.endbidding  from Item as i where i.itemid = ?1";
		queryStrings[1] = "select b.bidid, b.currentbid, b.maximumbid, b.bidincrement  from in(i.bid) as b order by b.currentbid DESC";
		queryStrings[2] = "select b1.userid, b1.email, b1.name, b1.acctnum, b1.active  from in(b.fk_bidderid) as b1 ";
		queryStrings[3] = "select s.statusid, s.name, s.description  from in(i.fk_itemstatus) as s ";
		SdoPackage pack = SdoPackage.eINSTANCE;
		MediatorMetaData md = new MediatorMetaData(pack.getFindHighestBid(),
				queryStrings, pattern);
		md.addAbstractSchemaNameMapping("Item", pack.getBidItemSDO());
		md.addAbstractSchemaNameMapping("Bid", pack.getBidSDO());
		md.addAbstractSchemaNameMapping("Registration", pack.getBidderSDO());
		md.addAbstractSchemaNameMapping("Status", pack.getStatusSDO());
		return md;
	}

	/**
	 * Return a FindHighestBid which is the root object of the query.
	 * The FindHighestBid object will contain references to all SDOs
	 * returned in the query.
	 * @param whereClauseValues Object[] the array of the values to be passed to the whereclause.
	 * The order of attributes in the array should exactly be same as defined in the Query.
	 * @generated
	 */

	public FindHighestBid getFindHighestBidGen(
			java.io.Serializable[] whereClauseValues) throws FindException {

		try {
			return doGetFindHighestBid(null, whereClauseValues);

		} catch (Exception ex) {
			throw new FindException(
					"System error while executing query to populate \"FindHighestBid\".",
					ex);
		}
	}

	/** 
	 * @generated 
	 */

	private FindHighestBid doGetFindHighestBid(
			String[] queryStringOverridesWithWhereClause,
			Object[] whereClauseValues) throws QueryException,
			MediatorMetaDataNotFoundException {
		Mediator mediator = mediatorCache.createMediator(SdoPackage.eINSTANCE
				.getFindHighestBid(), queryStringOverridesWithWhereClause,
				whereClauseValues);

		return (FindHighestBid) mediator.getGraph();
	}

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * FindHighestBid.
	 * @ejb.interface-method
	 *  view-type="both"
	 * @generated
	 */
	public void applyFindHighestBidChanges(FindHighestBid root)
			throws ApplyRootChangesFailedException {
		try {
			doApplyChanges(root);
		} catch (Exception e) {
			throw new ApplyRootChangesFailedException(
					"System error while applying changes to \"FindHighestBid\".",
					e);
		}
	}

	/**
	 * Return a LiteUserSDO array of active users.
	 * returned in the query.
	 * @return LiteUserSDO an array of active users.
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public LiteUserSDO[] getFindActiveUsers() throws FindException {
		return getFindActiveUsersGen(new Serializable[] {})
				.getLiteUserSDOAsArray();
	}

	/**
	 * Return a BidSDO object for the Item that has the maximum bid value.
	 * @param itemId Integer the item primary key id.
	 * @return BidSDO the highest bid value object. 
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public BidSDO getFindHighestBid(Integer itemId) throws FindException {
		List list = getFindHighestBidGen(new Serializable[] { itemId })
				.getBidItemSDOAsArray()[0].getBid();
		return (list.size() > 0) ? (BidSDO) list.get(0) : null;
	}

	/**
	 * Return an array of Items for this Category.
	 * @param categoryId Integer the description of the item.
	 * @return SellerItemSDO[] an array of Items for this Category.
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public SellerItemSDO[] getCategoryItems(Integer categoryId)
			throws FindException {
		return getFindItemsByCategory(new Serializable[] { categoryId })
				.getSellerItemSDOAsArray();
	}

	/**
	 * Return an array of bid items that match the description and have value
	 * less than the passed ordered by value or expriation (orderByIndex=0=Value,
	 *  orderByIndex=1=Expiration)
	 * @param searchParam String the description of the item.
	 * @param maxprice Integer the maximum value of the item.
	 * @param orderbyIndex Integer pass to determine how to order (orderByIndex=0=Value,
	 *  orderByIndex=1=Expiration).
	 * @return BidItemSDO[] an array of bid items
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public BidItemSDO[] getItems(String searchParam, Integer maxPrice,
			Integer orderbyIndex) throws FindException {
		BidItemSDO[] result = null;
		if (orderbyIndex != null && maxPrice == null) {
			maxPrice = new Integer(Integer.MAX_VALUE);
		}
		if (searchParam != null && maxPrice != null && orderbyIndex != null) {
			switch (orderbyIndex.intValue()) {
			case 0:
				result = getFindItemsByDescAndValOrderByVal(
						new Serializable[] { getSearchParamString(searchParam),
								maxPrice }).getBidItemSDOAsArray();
				break;
			case 1:
				result = getFindItemsByDescAndValOrderByExp(
						new Serializable[] { getSearchParamString(searchParam),
								maxPrice }).getBidItemSDOAsArray();
				break;
			}
		} else if (searchParam != null) {
			result = getFindItemsByDesc(
					new Serializable[] { getSearchParamString(searchParam) })
					.getBidItemSDOAsArray();
		} else if (maxPrice != null) {
			result = getFindItemsByValue(new Serializable[] { maxPrice })
					.getBidItemSDOAsArray();
		}
		return result;
	}

	private String getSearchParamString(String searchParam) {
		StringBuffer descBuf = new StringBuffer(searchParam);
		descBuf.insert(0, "%");
		descBuf.append("%");
		return descBuf.toString();
	}

	/**
	 * @return
	 */
	private OIDTypeMap getOIDTypeMap() {
		if (OID_TYPE_MAP == null) {
			OID_TYPE_MAP = new OIDTypeMap();
			SdoPackage pack = SdoPackage.eINSTANCE;
			OID_TYPE_MAP.addTypeEntry(pack.getAccountsPayableSDO(),
					AccountspayableLocalHome.ASN_NAME, pack
							.getAccountsPayableSDO_Apid());
			OID_TYPE_MAP.addTypeEntry(pack.getAddressSDO(),
					AddressLocalHome.ASN_NAME, pack.getAddressSDO_Addressid());
			OID_TYPE_MAP.addTypeEntry(pack.getBidSDO(), BidLocalHome.ASN_NAME,
					pack.getBidSDO_Bidid());
			OID_TYPE_MAP.addTypeEntry(pack.getSellerItemSDO(),
					ItemLocalHome.ASN_NAME, pack.getSellerItemSDO_Itemid());
			OID_TYPE_MAP.addTypeEntry(pack.getUserSDO(),
					RegistrationLocalHome.ASN_NAME, pack.getUserSDO_Userid());
			OID_TYPE_MAP.addTypeEntry(pack.getSaleSDO(),
					SaleLocalHome.ASN_NAME, pack.getSaleSDO_Saleid());
			OID_TYPE_MAP.addTypeEntry(pack.getStatusSDO(),
					StatusLocalHome.ASN_NAME, pack.getStatusSDO_Statusid());
			OID_TYPE_MAP.addTypeEntry(pack.getStatesSDO(),
					StatesLocalHome.ASN_NAME, pack.getStatesSDO_Stateid());
			OID_TYPE_MAP.addTypeEntry(pack.getCategorySDO(),
					CategoryLocalHome.ASN_NAME, pack.getCategorySDO_Catid());
		}
		return OID_TYPE_MAP;
	}

	protected OIDGeneratorSessionLocal createOIDGeneratorSessionLocal() {
		OIDGeneratorSessionLocalHome anOIDGeneratorSessionLocalHome = (OIDGeneratorSessionLocalHome) ServiceLocatorManager
				.getLocalHome(STATIC_OIDGeneratorSessionLocalHome_REF_NAME,
						STATIC_OIDGeneratorSessionLocalHome_CLASS);
		try {
			if (anOIDGeneratorSessionLocalHome != null)
				return anOIDGeneratorSessionLocalHome.create();
		} catch (javax.ejb.CreateException ce) {
			ce.printStackTrace();
		}
		return null;
	}

	/**
	 * Returns the default UserSDO
	 * @return UserSDO a newly created UserSDO Object, with default values
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public UserSDO createDefaultUserSDO() throws FindException {
		AuctionSystemFacadeLocal anAuctionSystemFacadeLocal = createAuctionSystemFacadeLocal();
		//get first state as default
		StatesSDO stateSDO = anAuctionSystemFacadeLocal
				.getAllStatesSDOObjects()[0];
		UserSDORoot root = SdoClientFactory.INSTANCE
				.createNewEmptyUserSDORoot();
		UserSDO registration = root.createUserSDO();
		registration.setName("name");
		registration.setEmail("email");
		registration.setAcctnum("0000");
		registration.setPasswd("password");
		registration.setCardtype("cardtype");
		registration.setShippingsame(new Integer(0));
		registration.setActive(new Integer(1));
		registration.setRank(new Integer(1));
		Date date = new Date();
		registration.setExpiry(new Timestamp(date.getTime()));
		AddressSDO shipAddress = root.createAddressSDO();
		shipAddress.setCity("Durham");
		shipAddress.setStreet("4205 S. Miami Blvd.");
		shipAddress.setZip("27560");
		shipAddress.setPhonenum("9192549000");
		shipAddress.setStateFromDiffRoot(stateSDO);
		registration.setFk_shipaddress(shipAddress);
		return registration;
	}

	/**
	 * Returns the default UserSDO
	 * @return SellerItemSDO a newly created SellerItemSDO Object
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public SellerItemSDO createItem(Integer userId, Integer categoryId,
			String title, String description, Integer startingBid,
			Integer value, Date startBidding, Date endBidding,
			String imagePath, String imageSmallPath) throws CreateException,
			FindException {
		if (userId == null || categoryId == null) {
			throw new CreateException(
					"System error while creating item \"createItem\": categoryId or the userId is null");
		}
		SellerSDO sellerSDO = this.getSellerSDOByKey(userId);
		CategorySDO catSDO = this.createAuctionSystemFacadeLocal()
				.getCategorySDOByKey(categoryId);
		SellerItemSDORoot root = SdoClientFactory.INSTANCE
				.createNewEmptySellerItemSDORoot();
		SellerItemSDO itemSDO = root.createSellerItemSDO();
		try {
			itemSDO.setTitle(title);
			itemSDO.setDescription(description);
			itemSDO.setStartingbid(startingBid);
			itemSDO.setValue(value);
			itemSDO.setStartBiddingDate(startBidding);
			itemSDO.setEndBiddingDate(endBidding);
			itemSDO.setImagepath(imagePath);
			itemSDO.setImagesmallpath(imageSmallPath);
			//set the seller SDO from a different datagraph
			itemSDO.setSellerFromDiffRoot(sellerSDO);
			//set the Category SDO from a different datagraph
			itemSDO.setCategoryFromDiffRoot(catSDO);
			doApplyChanges(itemSDO);
		} catch (Exception ex) {
			throw new CreateException(
					"System error while creating item \"createItem\".", ex);
		}
		return itemSDO;
	}

	/**
	 * Returns the UserSDO for the email and password supplied
	 * @param email String for the email.
	 * @param password String for the password.
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public UserSDO getUser(String email, String password) throws FindException {
		String[] valueArray = { email, password };
		UserSDO[] array = getFindUserByEmailPassword(valueArray)
				.getUserSDOAsArray();
		return (array == null || array.length == 0) ? null : array[0];
	}

	/**
	 * Returns true if the UserSDO is of role Admin
	 * @param UserSDO the user SDO to be tested for admin.
	 * @ejb.interface-method
	 *  view-type="both"
	 */

	public boolean isAdminUser(Integer userId) throws FindException {
		/*		AuctionSystemFacadeLocal anAuctionSystemFacadeLocal = createAuctionSystemFacadeLocal();
		 UserSDO user = this.getUserSDOByKey(userId);
		 UsertoroleSDO[] array = user.getUsertoroleAsArray();
		 for (int index = 0; index < array.length; ++index) {
		 RoleSDO aRoleSDO = anAuctionSystemFacadeLocal
		 .getRoleSDOByKey(array[index].getRoleid());
		 if (aRoleSDO.getRolename().equalsIgnoreCase("ADMIN")) {
		 return true;
		 }
		 }
		 return false;
		 */
		return true;
	}

	/**
	 * Creates Bid on the item for the user
	 * @param Integer the userId for the Bidder.
	 * @param Integer the itemId for the bid item.
	 * @param Integer the currentBid value for this bid.
	 * @return Integer the id for the newly created Bid
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public Integer createBid(Integer userId, Integer itemId, Integer currentBid)
			throws FindException {
		BidSDO bidSDO = null;
		try {
			BidderSDO bidderSDO = getBidderSDOByKey(userId);
			BidItemSDO bidItemSDO = getBidItemSDOByKey(itemId);
			bidSDO = ((BidItemSDORoot) bidItemSDO.getDataGraph()
					.getRootObject()).createBidSDO();
			bidSDO.setCurrentbid(currentBid);
			bidSDO.setBidderFromDiffRoot(bidderSDO);
			bidSDO.setFk_itemid(bidItemSDO);
			doApplyChanges(bidSDO);
		} catch (Exception ex) {
			throw new FindException("System error while creating new bid.", ex);
		}
		return bidSDO.getBidid();
	}

	/**
	 * Changes user status for active
	 * @param Integer the userId for the User.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public void activateUser(Integer userId) throws FindException {
		activateUser(userId, new Integer(1));
	}

	/**
	 * Changes user status for de-active
	 * @param Integer the userId for the User.
	 * @ejb.interface-method
	 *  view-type="both"
	 */
	public void deActivateUser(Integer userId) throws FindException {
		activateUser(userId, new Integer(0));
	}

	/**
	 * Changes user status for active
	 * @param Integer the userId for the User.
	 * @param Integer the active value for the user, set 1 to activate user and 0 to deactivate user
	 */
	private void activateUser(Integer userId, Integer active)
			throws FindException {
		try {
			UserSDO userSDO = getUserSDOByKey(userId);
			userSDO.setActive(active);
			doApplyChanges(userSDO);
		} catch (Exception ex) {
			throw new FindException("System error while deactivating User .",
					ex);
		}
	}

	protected AuctionSystemFacadeLocal createAuctionSystemFacadeLocal() {
		AuctionSystemFacadeLocalHome anAuctionSystemFacadeLocalHome = (AuctionSystemFacadeLocalHome) ServiceLocatorManager
				.getLocalHome(STATIC_AuctionSystemFacadeLocalHome_REF_NAME,
						STATIC_AuctionSystemFacadeLocalHome_CLASS);
		try {
			if (anAuctionSystemFacadeLocalHome != null)
				return anAuctionSystemFacadeLocalHome.create();
		} catch (javax.ejb.CreateException ce) {
			ce.printStackTrace();
		}
		return null;
	}

}
