package sample;

/**
 * Remote interface for AuctionSystemFacade bean.
 */
public interface AuctionSystemFacadeRemote extends javax.ejb.EJBObject {
	/**
	 * Return an array of "CategorySDO" value-objects from the database.
	 */
	public sample.sdo.CategorySDO[] getAllCategorySDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.CategorySDO getCategorySDOByKey(
			java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Persist a new "CategorySDO" value-object.
	 */
	public sample.sdo.CategorySDO createCategorySDO(sample.sdo.CategorySDO data)
			throws com.ibm.websphere.sbf.exceptions.CreateException,
			java.rmi.RemoteException;

	/**
	 * Update a "CategorySDO" value-object.
	 */
	public void updateCategorySDO(sample.sdo.CategorySDO data)
			throws com.ibm.websphere.sbf.exceptions.UpdateException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * CategorySDORoot.
	 */
	public void applyCategorySDORootChanges(sample.sdo.CategorySDORoot root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a CategorySDORoot which is the root object of the query.
	 * The CategorySDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.CategorySDORoot getCategorySDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "CategoryLiteSDO" value-objects from the database.
	 */
	public sample.sdo.CategoryLiteSDO[] getAllCategoryLiteSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.CategoryLiteSDO getCategoryLiteSDOByKey(
			java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return a CategoryLiteSDORoot which is the root object of the query.
	 * The CategoryLiteSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.CategoryLiteSDORoot getCategoryLiteSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.StatesSDO getStatesSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Persist a new "StatesSDO" value-object.
	 */
	public sample.sdo.StatesSDO createStatesSDO(sample.sdo.StatesSDO data)
			throws com.ibm.websphere.sbf.exceptions.CreateException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "StatusSDO" value-objects from the database.
	 */
	public sample.sdo.StatusSDO[] getAllStatusSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.StatusSDO getStatusSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Persist a new "StatusSDO" value-object.
	 */
	public sample.sdo.StatusSDO createStatusSDO(sample.sdo.StatusSDO data)
			throws com.ibm.websphere.sbf.exceptions.CreateException,
			java.rmi.RemoteException;

	/**
	 * Update a "StatusSDO" value-object.
	 */
	public void updateStatusSDO(sample.sdo.StatusSDO data)
			throws com.ibm.websphere.sbf.exceptions.UpdateException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * StatusSDORoot.
	 */
	public void applyStatusSDORootChanges(sample.sdo.StatusSDORoot root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a StatusSDORoot which is the root object of the query.
	 * The StatusSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.StatusSDORoot getStatusSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	

	

	/**
	 * Return an array of "StatesSDO" value-objects from the database.
	 */
	public sample.sdo.StatesSDO[] getAllStatesSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Update a "StatesSDO" value-object.
	 */
	public void updateStatesSDO(sample.sdo.StatesSDO data)
			throws com.ibm.websphere.sbf.exceptions.UpdateException,
			java.rmi.RemoteException;

	/**
	 * Delete a "StatesSDO" value-object.
	 */
	public void deleteStatesSDO(sample.sdo.StatesSDO data)
			throws com.ibm.websphere.sbf.exceptions.DeleteException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * StatesSDORoot.
	 */
	public void applyStatesSDORootChanges(sample.sdo.StatesSDORoot root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a StatesSDORoot which is the root object of the query.
	 * The StatesSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.StatesSDORoot getStatesSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

}