package sample;

/**
 * Remote interface for UserFacade bean.
 */
public interface UserFacadeRemote extends javax.ejb.EJBObject {
	/**
	 * Return an array of "UserSDO" value-objects from the database.
	 */
	public sample.sdo.UserSDO[] getAllUserSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.UserSDO getUserSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Persist a new "UserSDO" value-object.
	 */
	public sample.sdo.UserSDO createUserSDO(sample.sdo.UserSDO data)
			throws com.ibm.websphere.sbf.exceptions.CreateException,
			java.rmi.RemoteException;

	/**
	 * Update a "UserSDO" value-object.
	 */
	public void updateUserSDO(sample.sdo.UserSDO data)
			throws com.ibm.websphere.sbf.exceptions.UpdateException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * UserSDORoot.
	 */
	public void applyUserSDORootChanges(sample.sdo.UserSDORoot root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a UserSDORoot which is the root object of the query.
	 * The UserSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.UserSDORoot getUserSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "LiteUserSDO" value-objects from the database.
	 */
	public sample.sdo.LiteUserSDO[] getAllLiteUserSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.LiteUserSDO getLiteUserSDOByKey(
			java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return a LiteUserSDORoot which is the root object of the query.
	 * The LiteUserSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.LiteUserSDORoot getLiteUserSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "BidderSDO" value-objects from the database.
	 */
	public sample.sdo.BidderSDO[] getAllBidderSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.BidSDO getBidSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.BidderSDO getBidderSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return a BidderSDORoot which is the root object of the query.
	 * The BidderSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.BidderSDORoot getBidderSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "SellerSDO" value-objects from the database.
	 */
	public sample.sdo.SellerSDO[] getAllSellerSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.SellerSDO getSellerSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return a SellerSDORoot which is the root object of the query.
	 * The SellerSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.SellerSDORoot getSellerSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "BidSDO" value-objects from the database.
	 */
	public sample.sdo.BidSDO[] getAllBidSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Update a "BidSDO" value-object.
	 */
	public void updateBidSDO(sample.sdo.BidSDO data)
			throws com.ibm.websphere.sbf.exceptions.UpdateException,
			java.rmi.RemoteException;

	/**
	 * Delete a "BidSDO" value-object.
	 */
	public void deleteBidSDO(sample.sdo.BidSDO data)
			throws com.ibm.websphere.sbf.exceptions.DeleteException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * BidSDORoot.
	 */
	public void applyBidSDORootChanges(sample.sdo.BidSDORoot root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a BidSDORoot which is the root object of the query.
	 * The BidSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.BidSDORoot getBidSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "SellerItemSDO" value-objects from the database.
	 */
	public sample.sdo.SellerItemSDO[] getAllSellerItemSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.SellerItemSDO getSellerItemSDOByKey(
			java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Persist a new "UserSDO" value-object.
	 */
	public sample.sdo.SellerItemSDO createSellerItemSDO(
			sample.sdo.SellerItemSDO data)
			throws com.ibm.websphere.sbf.exceptions.CreateException,
			java.rmi.RemoteException;

	/**
	 * Update a "SellerItemSDO" value-object.
	 */
	public void updateSellerItemSDO(sample.sdo.SellerItemSDO data)
			throws com.ibm.websphere.sbf.exceptions.UpdateException,
			java.rmi.RemoteException;

	/**
	 * Delete a "SellerItemSDO" value-object.
	 */
	public void deleteSellerItemSDO(sample.sdo.SellerItemSDO data)
			throws com.ibm.websphere.sbf.exceptions.DeleteException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * SellerItemSDORoot.
	 */
	public void applySellerItemSDORootChanges(sample.sdo.SellerItemSDORoot root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a SellerItemSDORoot which is the root object of the query.
	 * The SellerItemSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.SellerItemSDORoot getSellerItemSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of "BidItemSDO" value-objects from the database.
	 */
	public sample.sdo.BidItemSDO[] getAllBidItemSDOObjects()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/** 
	 */
	public sample.sdo.BidItemSDO getBidItemSDOByKey(java.lang.Integer primaryKey)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return a BidItemSDORoot which is the root object of the query.
	 * The BidItemSDORoot object will contain references to all SDOs
	 * returned in the query.
	 */
	public sample.sdo.BidItemSDORoot getBidItemSDORoot()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * FindActiveUsers.
	 */
	public void applyFindActiveUsersChanges(sample.sdo.FindActiveUsers root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Apply any and all changes to every SDO change contained by the passed
	 * FindHighestBid.
	 */
	public void applyFindHighestBidChanges(sample.sdo.FindHighestBid root)
			throws com.ibm.websphere.sbf.exceptions.ApplyRootChangesFailedException,
			java.rmi.RemoteException;

	/**
	 * Return a LiteUserSDO array of active users.
	 * returned in the query.
	 */
	public sample.sdo.LiteUserSDO[] getFindActiveUsers()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return a BidSDO object for the Item that has the maximum bid value.
	 */
	public sample.sdo.BidSDO getFindHighestBid(java.lang.Integer itemId)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of Items for this Category.
	 */
	public sample.sdo.SellerItemSDO[] getCategoryItems(
			java.lang.Integer categoryId)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Return an array of bid items that match the description and have value
	 * less than the passed ordered by value or expriation (orderByIndex=0=Value,
	 *  orderByIndex=1=Expiration)
	 */
	public sample.sdo.BidItemSDO[] getItems(java.lang.String searchParam,
			java.lang.Integer maxPrice, java.lang.Integer orderbyIndex)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Returns the default UserSDO
	 */
	public sample.sdo.UserSDO createDefaultUserSDO()
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Returns the default UserSDO
	 */
	public sample.sdo.SellerItemSDO createItem(java.lang.Integer userId,
			java.lang.Integer categoryId, java.lang.String title,
			java.lang.String description, java.lang.Integer startingBid,
			java.lang.Integer value, java.util.Date startBidding,
			java.util.Date endBidding, java.lang.String imagePath,
			java.lang.String imageSmallPath)
			throws com.ibm.websphere.sbf.exceptions.CreateException,
			com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Returns the UserSDO for the email and password supplied
	 */
	public sample.sdo.UserSDO getUser(java.lang.String email,
			java.lang.String password)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Returns true if the UserSDO is of role Admin
	 */
	public boolean isAdminUser(java.lang.Integer userId)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Returns UserSDO array for the roleId
	 */
	public sample.sdo.UserSDO[] getUsersInRole(java.lang.Integer roleId)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Creates Bid on the item for the user
	 */
	public java.lang.Integer createBid(java.lang.Integer userId,
			java.lang.Integer itemId, java.lang.Integer currentBid)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Changes user status for active
	 */
	public void activateUser(java.lang.Integer userId)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

	/**
	 * Changes user status for de-active
	 */
	public void deActivateUser(java.lang.Integer userId)
			throws com.ibm.websphere.sbf.exceptions.FindException,
			java.rmi.RemoteException;

}