/**
 * <copyright>
 * </copyright>
 *
 * $Id: SdoAdapterFactory.java,v 1.3 2004/10/16 05:30:57 danberg Exp $
 */
package sample.sdo.util;

import commonj.sdo.DataObject;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import sample.sdo.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see sample.sdo.SdoPackage
 * @generated
 */
public class SdoAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static SdoPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SdoAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = SdoPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch the delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SdoSwitch modelSwitch =
    new SdoSwitch()
    {
      public Object caseAccountsPayableSDO(AccountsPayableSDO object)
      {
        return createAccountsPayableSDOAdapter();
      }
      public Object caseAddressSDO(AddressSDO object)
      {
        return createAddressSDOAdapter();
      }
      public Object caseBidItemSDO(BidItemSDO object)
      {
        return createBidItemSDOAdapter();
      }
      public Object caseBidItemSDORoot(BidItemSDORoot object)
      {
        return createBidItemSDORootAdapter();
      }
      public Object caseBidSDO(BidSDO object)
      {
        return createBidSDOAdapter();
      }
      public Object caseBidSDORoot(BidSDORoot object)
      {
        return createBidSDORootAdapter();
      }
      public Object caseBidderSDO(BidderSDO object)
      {
        return createBidderSDOAdapter();
      }
      public Object caseBidderSDORoot(BidderSDORoot object)
      {
        return createBidderSDORootAdapter();
      }
      public Object caseCategoryLiteSDO(CategoryLiteSDO object)
      {
        return createCategoryLiteSDOAdapter();
      }
      public Object caseCategoryLiteSDORoot(CategoryLiteSDORoot object)
      {
        return createCategoryLiteSDORootAdapter();
      }
      public Object caseCategorySDO(CategorySDO object)
      {
        return createCategorySDOAdapter();
      }
      public Object caseCategorySDORoot(CategorySDORoot object)
      {
        return createCategorySDORootAdapter();
      }
      public Object caseFindActiveUsers(FindActiveUsers object)
      {
        return createFindActiveUsersAdapter();
      }
      public Object caseFindHighestBid(FindHighestBid object)
      {
        return createFindHighestBidAdapter();
      }
      public Object caseFindItemsByCategory(FindItemsByCategory object)
      {
        return createFindItemsByCategoryAdapter();
      }
      public Object caseFindItemsByDesc(FindItemsByDesc object)
      {
        return createFindItemsByDescAdapter();
      }
      public Object caseFindItemsByDescAndValOrderByExp(FindItemsByDescAndValOrderByExp object)
      {
        return createFindItemsByDescAndValOrderByExpAdapter();
      }
      public Object caseFindItemsByDescAndValOrderByVal(FindItemsByDescAndValOrderByVal object)
      {
        return createFindItemsByDescAndValOrderByValAdapter();
      }
      public Object caseFindItemsByValue(FindItemsByValue object)
      {
        return createFindItemsByValueAdapter();
      }
      public Object caseFindUserByEmailPassword(FindUserByEmailPassword object)
      {
        return createFindUserByEmailPasswordAdapter();
      }
      public Object caseLiteUserSDO(LiteUserSDO object)
      {
        return createLiteUserSDOAdapter();
      }
      public Object caseLiteUserSDORoot(LiteUserSDORoot object)
      {
        return createLiteUserSDORootAdapter();
      }
      public Object caseSaleSDO(SaleSDO object)
      {
        return createSaleSDOAdapter();
      }
      public Object caseSellerItemSDO(SellerItemSDO object)
      {
        return createSellerItemSDOAdapter();
      }
      public Object caseSellerItemSDORoot(SellerItemSDORoot object)
      {
        return createSellerItemSDORootAdapter();
      }
      public Object caseSellerSDO(SellerSDO object)
      {
        return createSellerSDOAdapter();
      }
      public Object caseSellerSDORoot(SellerSDORoot object)
      {
        return createSellerSDORootAdapter();
      }
      public Object caseStatesSDO(StatesSDO object)
      {
        return createStatesSDOAdapter();
      }
      public Object caseStatesSDORoot(StatesSDORoot object)
      {
        return createStatesSDORootAdapter();
      }
      public Object caseStatusSDO(StatusSDO object)
      {
        return createStatusSDOAdapter();
      }
      public Object caseStatusSDORoot(StatusSDORoot object)
      {
        return createStatusSDORootAdapter();
      }
      public Object caseUserSDO(UserSDO object)
      {
        return createUserSDOAdapter();
      }
      public Object caseUserSDORoot(UserSDORoot object)
      {
        return createUserSDORootAdapter();
      }
      public Object caseDataObject(DataObject object)
      {
        return createDataObjectAdapter();
      }
      public Object defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  public Adapter createAdapter(Notifier target)
  {
    return (Adapter)modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.AccountsPayableSDO <em>Accounts Payable SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.AccountsPayableSDO
   * @generated
   */
  public Adapter createAccountsPayableSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.AddressSDO <em>Address SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.AddressSDO
   * @generated
   */
  public Adapter createAddressSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.BidItemSDO <em>Bid Item SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.BidItemSDO
   * @generated
   */
  public Adapter createBidItemSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.BidItemSDORoot <em>Bid Item SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.BidItemSDORoot
   * @generated
   */
  public Adapter createBidItemSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.BidSDO <em>Bid SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.BidSDO
   * @generated
   */
  public Adapter createBidSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.BidSDORoot <em>Bid SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.BidSDORoot
   * @generated
   */
  public Adapter createBidSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.BidderSDO <em>Bidder SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.BidderSDO
   * @generated
   */
  public Adapter createBidderSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.BidderSDORoot <em>Bidder SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.BidderSDORoot
   * @generated
   */
  public Adapter createBidderSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.CategoryLiteSDO <em>Category Lite SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.CategoryLiteSDO
   * @generated
   */
  public Adapter createCategoryLiteSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.CategoryLiteSDORoot <em>Category Lite SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.CategoryLiteSDORoot
   * @generated
   */
  public Adapter createCategoryLiteSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.CategorySDO <em>Category SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.CategorySDO
   * @generated
   */
  public Adapter createCategorySDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.CategorySDORoot <em>Category SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.CategorySDORoot
   * @generated
   */
  public Adapter createCategorySDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindActiveUsers <em>Find Active Users</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindActiveUsers
   * @generated
   */
  public Adapter createFindActiveUsersAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindHighestBid <em>Find Highest Bid</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindHighestBid
   * @generated
   */
  public Adapter createFindHighestBidAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindItemsByCategory <em>Find Items By Category</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindItemsByCategory
   * @generated
   */
  public Adapter createFindItemsByCategoryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindItemsByDesc <em>Find Items By Desc</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindItemsByDesc
   * @generated
   */
  public Adapter createFindItemsByDescAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindItemsByDescAndValOrderByExp <em>Find Items By Desc And Val Order By Exp</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindItemsByDescAndValOrderByExp
   * @generated
   */
  public Adapter createFindItemsByDescAndValOrderByExpAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindItemsByDescAndValOrderByVal <em>Find Items By Desc And Val Order By Val</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindItemsByDescAndValOrderByVal
   * @generated
   */
  public Adapter createFindItemsByDescAndValOrderByValAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindItemsByValue <em>Find Items By Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindItemsByValue
   * @generated
   */
  public Adapter createFindItemsByValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.FindUserByEmailPassword <em>Find User By Email Password</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.FindUserByEmailPassword
   * @generated
   */
  public Adapter createFindUserByEmailPasswordAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.LiteUserSDO <em>Lite User SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.LiteUserSDO
   * @generated
   */
  public Adapter createLiteUserSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.LiteUserSDORoot <em>Lite User SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.LiteUserSDORoot
   * @generated
   */
  public Adapter createLiteUserSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.SaleSDO <em>Sale SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.SaleSDO
   * @generated
   */
  public Adapter createSaleSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.SellerItemSDO <em>Seller Item SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.SellerItemSDO
   * @generated
   */
  public Adapter createSellerItemSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.SellerItemSDORoot <em>Seller Item SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.SellerItemSDORoot
   * @generated
   */
  public Adapter createSellerItemSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.SellerSDO <em>Seller SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.SellerSDO
   * @generated
   */
  public Adapter createSellerSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.SellerSDORoot <em>Seller SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.SellerSDORoot
   * @generated
   */
  public Adapter createSellerSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.StatesSDO <em>States SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.StatesSDO
   * @generated
   */
  public Adapter createStatesSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.StatesSDORoot <em>States SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.StatesSDORoot
   * @generated
   */
  public Adapter createStatesSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.StatusSDO <em>Status SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.StatusSDO
   * @generated
   */
  public Adapter createStatusSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.StatusSDORoot <em>Status SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.StatusSDORoot
   * @generated
   */
  public Adapter createStatusSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.UserSDO <em>User SDO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.UserSDO
   * @generated
   */
  public Adapter createUserSDOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link sample.sdo.UserSDORoot <em>User SDO Root</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see sample.sdo.UserSDORoot
   * @generated
   */
  public Adapter createUserSDORootAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link commonj.sdo.DataObject <em>Data Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see commonj.sdo.DataObject
   * @generated
   */
  public Adapter createDataObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //SdoAdapterFactory
