/**
 * <copyright>
 * </copyright>
 *
 * $Id: SdoSwitch.java,v 1.3 2004/10/16 05:30:57 danberg Exp $
 */
package sample.sdo.util;

import commonj.sdo.DataObject;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import sample.sdo.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see sample.sdo.SdoPackage
 * @generated
 */
public class SdoSwitch 
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static SdoPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SdoSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = SdoPackage.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  public Object doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected Object doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch((EClass)eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected Object doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case SdoPackage.ACCOUNTS_PAYABLE_SDO:
      {
        AccountsPayableSDO accountsPayableSDO = (AccountsPayableSDO)theEObject;
        Object result = caseAccountsPayableSDO(accountsPayableSDO);
        if (result == null) result = caseDataObject(accountsPayableSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.ADDRESS_SDO:
      {
        AddressSDO addressSDO = (AddressSDO)theEObject;
        Object result = caseAddressSDO(addressSDO);
        if (result == null) result = caseDataObject(addressSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.BID_ITEM_SDO:
      {
        BidItemSDO bidItemSDO = (BidItemSDO)theEObject;
        Object result = caseBidItemSDO(bidItemSDO);
        if (result == null) result = caseDataObject(bidItemSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.BID_ITEM_SDO_ROOT:
      {
        BidItemSDORoot bidItemSDORoot = (BidItemSDORoot)theEObject;
        Object result = caseBidItemSDORoot(bidItemSDORoot);
        if (result == null) result = caseDataObject(bidItemSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.BID_SDO:
      {
        BidSDO bidSDO = (BidSDO)theEObject;
        Object result = caseBidSDO(bidSDO);
        if (result == null) result = caseDataObject(bidSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.BID_SDO_ROOT:
      {
        BidSDORoot bidSDORoot = (BidSDORoot)theEObject;
        Object result = caseBidSDORoot(bidSDORoot);
        if (result == null) result = caseDataObject(bidSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.BIDDER_SDO:
      {
        BidderSDO bidderSDO = (BidderSDO)theEObject;
        Object result = caseBidderSDO(bidderSDO);
        if (result == null) result = caseDataObject(bidderSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.BIDDER_SDO_ROOT:
      {
        BidderSDORoot bidderSDORoot = (BidderSDORoot)theEObject;
        Object result = caseBidderSDORoot(bidderSDORoot);
        if (result == null) result = caseDataObject(bidderSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.CATEGORY_LITE_SDO:
      {
        CategoryLiteSDO categoryLiteSDO = (CategoryLiteSDO)theEObject;
        Object result = caseCategoryLiteSDO(categoryLiteSDO);
        if (result == null) result = caseDataObject(categoryLiteSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.CATEGORY_LITE_SDO_ROOT:
      {
        CategoryLiteSDORoot categoryLiteSDORoot = (CategoryLiteSDORoot)theEObject;
        Object result = caseCategoryLiteSDORoot(categoryLiteSDORoot);
        if (result == null) result = caseDataObject(categoryLiteSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.CATEGORY_SDO:
      {
        CategorySDO categorySDO = (CategorySDO)theEObject;
        Object result = caseCategorySDO(categorySDO);
        if (result == null) result = caseDataObject(categorySDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.CATEGORY_SDO_ROOT:
      {
        CategorySDORoot categorySDORoot = (CategorySDORoot)theEObject;
        Object result = caseCategorySDORoot(categorySDORoot);
        if (result == null) result = caseDataObject(categorySDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_ACTIVE_USERS:
      {
        FindActiveUsers findActiveUsers = (FindActiveUsers)theEObject;
        Object result = caseFindActiveUsers(findActiveUsers);
        if (result == null) result = caseDataObject(findActiveUsers);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_HIGHEST_BID:
      {
        FindHighestBid findHighestBid = (FindHighestBid)theEObject;
        Object result = caseFindHighestBid(findHighestBid);
        if (result == null) result = caseDataObject(findHighestBid);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_ITEMS_BY_CATEGORY:
      {
        FindItemsByCategory findItemsByCategory = (FindItemsByCategory)theEObject;
        Object result = caseFindItemsByCategory(findItemsByCategory);
        if (result == null) result = caseDataObject(findItemsByCategory);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_ITEMS_BY_DESC:
      {
        FindItemsByDesc findItemsByDesc = (FindItemsByDesc)theEObject;
        Object result = caseFindItemsByDesc(findItemsByDesc);
        if (result == null) result = caseDataObject(findItemsByDesc);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_ITEMS_BY_DESC_AND_VAL_ORDER_BY_EXP:
      {
        FindItemsByDescAndValOrderByExp findItemsByDescAndValOrderByExp = (FindItemsByDescAndValOrderByExp)theEObject;
        Object result = caseFindItemsByDescAndValOrderByExp(findItemsByDescAndValOrderByExp);
        if (result == null) result = caseDataObject(findItemsByDescAndValOrderByExp);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_ITEMS_BY_DESC_AND_VAL_ORDER_BY_VAL:
      {
        FindItemsByDescAndValOrderByVal findItemsByDescAndValOrderByVal = (FindItemsByDescAndValOrderByVal)theEObject;
        Object result = caseFindItemsByDescAndValOrderByVal(findItemsByDescAndValOrderByVal);
        if (result == null) result = caseDataObject(findItemsByDescAndValOrderByVal);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_ITEMS_BY_VALUE:
      {
        FindItemsByValue findItemsByValue = (FindItemsByValue)theEObject;
        Object result = caseFindItemsByValue(findItemsByValue);
        if (result == null) result = caseDataObject(findItemsByValue);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.FIND_USER_BY_EMAIL_PASSWORD:
      {
        FindUserByEmailPassword findUserByEmailPassword = (FindUserByEmailPassword)theEObject;
        Object result = caseFindUserByEmailPassword(findUserByEmailPassword);
        if (result == null) result = caseDataObject(findUserByEmailPassword);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.LITE_USER_SDO:
      {
        LiteUserSDO liteUserSDO = (LiteUserSDO)theEObject;
        Object result = caseLiteUserSDO(liteUserSDO);
        if (result == null) result = caseDataObject(liteUserSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.LITE_USER_SDO_ROOT:
      {
        LiteUserSDORoot liteUserSDORoot = (LiteUserSDORoot)theEObject;
        Object result = caseLiteUserSDORoot(liteUserSDORoot);
        if (result == null) result = caseDataObject(liteUserSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.SALE_SDO:
      {
        SaleSDO saleSDO = (SaleSDO)theEObject;
        Object result = caseSaleSDO(saleSDO);
        if (result == null) result = caseDataObject(saleSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.SELLER_ITEM_SDO:
      {
        SellerItemSDO sellerItemSDO = (SellerItemSDO)theEObject;
        Object result = caseSellerItemSDO(sellerItemSDO);
        if (result == null) result = caseDataObject(sellerItemSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.SELLER_ITEM_SDO_ROOT:
      {
        SellerItemSDORoot sellerItemSDORoot = (SellerItemSDORoot)theEObject;
        Object result = caseSellerItemSDORoot(sellerItemSDORoot);
        if (result == null) result = caseDataObject(sellerItemSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.SELLER_SDO:
      {
        SellerSDO sellerSDO = (SellerSDO)theEObject;
        Object result = caseSellerSDO(sellerSDO);
        if (result == null) result = caseDataObject(sellerSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.SELLER_SDO_ROOT:
      {
        SellerSDORoot sellerSDORoot = (SellerSDORoot)theEObject;
        Object result = caseSellerSDORoot(sellerSDORoot);
        if (result == null) result = caseDataObject(sellerSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.STATES_SDO:
      {
        StatesSDO statesSDO = (StatesSDO)theEObject;
        Object result = caseStatesSDO(statesSDO);
        if (result == null) result = caseDataObject(statesSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.STATES_SDO_ROOT:
      {
        StatesSDORoot statesSDORoot = (StatesSDORoot)theEObject;
        Object result = caseStatesSDORoot(statesSDORoot);
        if (result == null) result = caseDataObject(statesSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.STATUS_SDO:
      {
        StatusSDO statusSDO = (StatusSDO)theEObject;
        Object result = caseStatusSDO(statusSDO);
        if (result == null) result = caseDataObject(statusSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.STATUS_SDO_ROOT:
      {
        StatusSDORoot statusSDORoot = (StatusSDORoot)theEObject;
        Object result = caseStatusSDORoot(statusSDORoot);
        if (result == null) result = caseDataObject(statusSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.USER_SDO:
      {
        UserSDO userSDO = (UserSDO)theEObject;
        Object result = caseUserSDO(userSDO);
        if (result == null) result = caseDataObject(userSDO);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SdoPackage.USER_SDO_ROOT:
      {
        UserSDORoot userSDORoot = (UserSDORoot)theEObject;
        Object result = caseUserSDORoot(userSDORoot);
        if (result == null) result = caseDataObject(userSDORoot);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Accounts Payable SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Accounts Payable SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAccountsPayableSDO(AccountsPayableSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Address SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Address SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAddressSDO(AddressSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bid Item SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bid Item SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBidItemSDO(BidItemSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bid Item SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bid Item SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBidItemSDORoot(BidItemSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bid SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bid SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBidSDO(BidSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bid SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bid SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBidSDORoot(BidSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bidder SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bidder SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBidderSDO(BidderSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Bidder SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Bidder SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBidderSDORoot(BidderSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Category Lite SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Category Lite SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseCategoryLiteSDO(CategoryLiteSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Category Lite SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Category Lite SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseCategoryLiteSDORoot(CategoryLiteSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Category SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Category SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseCategorySDO(CategorySDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Category SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Category SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseCategorySDORoot(CategorySDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Active Users</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Active Users</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindActiveUsers(FindActiveUsers object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Highest Bid</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Highest Bid</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindHighestBid(FindHighestBid object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Items By Category</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Items By Category</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindItemsByCategory(FindItemsByCategory object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Items By Desc</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Items By Desc</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindItemsByDesc(FindItemsByDesc object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Items By Desc And Val Order By Exp</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Items By Desc And Val Order By Exp</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindItemsByDescAndValOrderByExp(FindItemsByDescAndValOrderByExp object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Items By Desc And Val Order By Val</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Items By Desc And Val Order By Val</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindItemsByDescAndValOrderByVal(FindItemsByDescAndValOrderByVal object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find Items By Value</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find Items By Value</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindItemsByValue(FindItemsByValue object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Find User By Email Password</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Find User By Email Password</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseFindUserByEmailPassword(FindUserByEmailPassword object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Lite User SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Lite User SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseLiteUserSDO(LiteUserSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Lite User SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Lite User SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseLiteUserSDORoot(LiteUserSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Sale SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Sale SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSaleSDO(SaleSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Seller Item SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Seller Item SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSellerItemSDO(SellerItemSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Seller Item SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Seller Item SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSellerItemSDORoot(SellerItemSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Seller SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Seller SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSellerSDO(SellerSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Seller SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Seller SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSellerSDORoot(SellerSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>States SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>States SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseStatesSDO(StatesSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>States SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>States SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseStatesSDORoot(StatesSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Status SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Status SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseStatusSDO(StatusSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Status SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Status SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseStatusSDORoot(StatusSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>User SDO</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>User SDO</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseUserSDO(UserSDO object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>User SDO Root</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>User SDO Root</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseUserSDORoot(UserSDORoot object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Data Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Data Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseDataObject(DataObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  public Object defaultCase(EObject object)
  {
    return null;
  }

} //SdoSwitch
