package pagecode;

import java.util.Date;

import javax.ejb.CreateException;
import sample.UserFacadeLocal;
import sample.UserFacadeLocalHome;
import sample.sdo.BidItemSDO;
import sample.sdo.SellerItemSDO;

import com.ibm.etools.service.locator.ServiceLocatorManager;
import com.ibm.faces.component.html.HtmlOutputLinkEx;
import com.ibm.faces.component.html.HtmlScriptCollector;
import javax.faces.component.html.HtmlForm;
import com.ibm.faces.component.html.HtmlGraphicImageEx;
import com.ibm.faces.component.html.HtmlPanelBox;
import javax.faces.component.html.HtmlCommandLink;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.component.html.HtmlInputText;
import com.ibm.faces.component.html.HtmlCommandExButton;
import javax.faces.component.html.HtmlDataTable;
import javax.faces.component.UIColumn;
import com.ibm.faces.component.html.HtmlCommandExRowAction;
import com.ibm.faces.component.html.HtmlPagerDeluxe;
import javax.faces.component.UINamingContainer;
public class Itemlist extends PageCodeBase {

	/** Page Code JSF UI Fields
	 * @pcElementClass tag
	 */
	protected HtmlOutputLinkEx linkEx1;
	/** Page Code JSF UI Fields
	 * @pcElementClass tag
	 */
	protected HtmlOutputLinkEx linkEx2;
	/** Page Code JSF UI Getters
	 * @pcElementClass tag
	 */
	protected HtmlOutputLinkEx getLinkEx1() {
		if (linkEx1 == null) {
			linkEx1 = (HtmlOutputLinkEx) findComponentInRoot("linkEx1");
		}
		return linkEx1;
	}
	/** Page Code JSF UI Getters
	 * @pcElementClass tag
	 */
	protected HtmlOutputLinkEx getLinkEx2() {
		if (linkEx2 == null) {
			linkEx2 = (HtmlOutputLinkEx) findComponentInRoot("linkEx2");
		}
		return linkEx2;
	}
	public Date getNow() {
		return new Date();
	}
	
	protected BidItemSDO[] browseItems = null;
	protected SellerItemSDO[] categoryItems = null;

	private boolean isCategorySearch() {
		if((getRequestScope().get("categorysearch") != null) || (getTreeAttribute("categorysearch") != null)) {
			putTreeAttribute("categorysearch", new Object());
			return true;
		} else {
			return false;
		}
	}
	
	
	public BidItemSDO[] getItems() {
		if(isCategorySearch()) {
			return null;
		}
		
		if(getRequestScope().get("rebuilditemlist") != null) {
			// if the user searches again while on the item list page, we need to recreate
			// the list of items using the new search criteria
			getRequestScope().remove("rebuilditemlist");
			browseItems = null;
			categoryItems = null;
		}
		
		if(browseItems == null) {
			BrowseParams params = (BrowseParams) resolveExpression("#{browseParams}");
			if(params != null) {
				getUserFacadeLocalGetItemsParamBean().setSearchParam(params.getDescription());
				getUserFacadeLocalGetItemsParamBean().setMaxPrice(params.getMaxPrice());
				try {
					Integer orderbyIndex = Integer.decode(params.getOrderby());
					getUserFacadeLocalGetItemsParamBean().setOrderbyIndex(orderbyIndex);
				} catch (NumberFormatException nfe) {
				}
				doUserFacadeLocalGetItemsAction();
				browseItems = getUserFacadeLocalGetItemsResultBean();
			}
		}
		return browseItems;
	}

	public SellerItemSDO[] getCategoryItems() {
		if(getRequestScope().get("rebuilditemlist") != null) {
			// if the user searches again while on the item list page, we need to recreate
			// the list of items using the new search criteria
			getRequestScope().remove("rebuilditemlist");
			browseItems = null;
			categoryItems = null;
		}

		// check if the page was reached by picking a category
	    String catid = (String) getTreeAttribute("catid");
	    if(catid == null) {
	        catid = (String) getRequestParam().get("catid");
	    }
		if((catid != null) && (!"".equals(catid))) {
		    putTreeAttribute("catid", catid);
		    Integer key = Integer.decode(catid);
		    getUserFacadeLocalGetCategoryItemsParamBean().setCategoryId(key);
		    doUserFacadeLocalGetCategoryItemsAction();
		    categoryItems = getUserFacadeLocalGetCategoryItemsResultBean();
		}

		return categoryItems;
	}


	/** Page Code Data Fields
	 * @pcElementClass data
	 */
	protected UserFacadeLocal userFacadeLocal;
	private final static String STATIC_UserFacadeLocalHome_REF_NAME = "ejb/UserFacade";
	private final static Class STATIC_UserFacadeLocalHome_CLASS = UserFacadeLocalHome.class;
	/** 
	 */
	protected UserFacadeLocalGetItemsParamBean userFacadeLocalGetItemsParamBean;
	/** 
	 */
	protected BidItemSDO[] userFacadeLocalGetItemsResultBean;
	/** 
	 */
	protected UserFacadeLocalGetCategoryItemsParamBean userFacadeLocalGetCategoryItemsParamBean;
	/** 
	 */
	protected SellerItemSDO[] userFacadeLocalGetCategoryItemsResultBean;
	protected HtmlScriptCollector scriptCollector1;
	protected HtmlForm form1;
	protected HtmlGraphicImageEx imageEx1;
	protected HtmlPanelBox box4;
	protected HtmlCommandLink link1;
	protected HtmlForm catlistform;
	protected HtmlInputText keywords;
	protected HtmlCommandExButton button2;
	protected HtmlDataTable table1;
	protected UIColumn column1;
	protected HtmlOutputText textCatHeader;
	protected HtmlOutputText catname;
	protected HtmlScriptCollector scriptCollector2;
	protected HtmlDataTable table2;
	protected UIColumn column5;
	protected HtmlCommandExRowAction rowAction1;
	protected HtmlPanelBox box3;
	protected HtmlPagerDeluxe deluxe1;
	protected UIColumn column10;
	protected HtmlCommandExRowAction rowAction2;
	protected HtmlPanelBox box2;
	protected HtmlPagerDeluxe deluxe2;
	protected HtmlOutputText templateWelcomeText;
	protected HtmlCommandLink link2;
	protected HtmlPanelBox box1;
	protected HtmlCommandLink link3;
	protected HtmlCommandLink link4;
	protected UINamingContainer subview1;
	protected HtmlScriptCollector scriptCollectorCat1;
	protected HtmlCommandLink catlistlink;
	protected HtmlForm form2;
	protected UIColumn column6;
	protected HtmlOutputText titletext;
	protected UIColumn column2;
	protected HtmlOutputText desctext;
	protected UIColumn column3;
	protected HtmlGraphicImageEx image;
	protected UIColumn column4;
	protected HtmlOutputText endbidtext;
	protected HtmlDataTable table3;
	protected UIColumn column7;
	protected HtmlOutputText titletext2;
	protected UIColumn column117;
	protected HtmlOutputText desctext2;
	protected UIColumn column8;
	protected HtmlGraphicImageEx image101;
	protected UIColumn column9;
	protected HtmlOutputText endbidtext2;
	protected HtmlOutputText text17;
	protected UIColumn column12;
	protected HtmlOutputText valuetext2;
	protected UIColumn column11;
	protected HtmlOutputText valuetext;
	protected HtmlOutputText errortext;
	/** Page Code Actions
	 * @pcElementClass action
	 */
	public String doRowAction2Action() {
		int row = getRowAction2().getRowIndex();
        Integer id = getCategoryItems()[row].getItemid();
        getSessionScope().put("itemid", id);
        return "details";

}
   /** Page Code Actions
     * @pcElementClass action
     */
    public String doRowAction1Action() {
        int row = getRowAction1().getRowIndex();
        Integer id = getItems()[row].getItemid();
        getSessionScope().put("itemid", id);
        return "details";

    }
    
    public boolean getHasBrowseItems() {
       	BidItemSDO[] browseItems = getItems();
        if(browseItems == null) {
        	return false;
        } else {
        	return (browseItems.length > 0);
        }
    }
    
    public boolean getHasCategoryItems() {
       	SellerItemSDO[] catItems = getCategoryItems();
        if(catItems == null) {
        	return false;
        } else {
        	return (catItems.length > 0);
        }
    }
    
    public boolean getIsEmptyItemsList() {
    	return (!getHasBrowseItems() && !getHasCategoryItems());
    }

	/** Page Code Data Getters
	 * @pcElementClass data
	 */
	public void setUserFacadeLocal(UserFacadeLocal userFacadeLocal) {
		this.userFacadeLocal = userFacadeLocal;
	}
	/** Page Code Data Getters
	 * Page Code Data Getters Page Code Data Getters
	 * @pcElementClass data
	 * @beanType EJB_Session_Bean
	 * @methodEntry id=getItems(java.lang.String,java.lang.Integer,java.lang.Integer)/paramBean=3/resultBean=3/action=3
	 * @methodEntry id=getCategoryItems(java.lang.Integer)/paramBean=4/resultBean=4/action=4
	 */
	public UserFacadeLocal getUserFacadeLocal() {
		if (userFacadeLocal == null)
			userFacadeLocal = createUserFacadeLocal();
		return userFacadeLocal;
	}
	/** 
	 */
	public UserFacadeLocal createUserFacadeLocal() {

		UserFacadeLocalHome anUserFacadeLocalHome = (UserFacadeLocalHome) ServiceLocatorManager
				.getLocalHome(STATIC_UserFacadeLocalHome_REF_NAME,
						STATIC_UserFacadeLocalHome_CLASS);
		try {
			if (anUserFacadeLocalHome != null)
				return anUserFacadeLocalHome.create();
		} catch (CreateException ce) {
			ce.printStackTrace();
		}
		return null;
	}
	/** 
	 * @paramBean id=3
	 */
	public UserFacadeLocalGetItemsParamBean getUserFacadeLocalGetItemsParamBean() {
		if (userFacadeLocalGetItemsParamBean == null) {
			userFacadeLocalGetItemsParamBean = new UserFacadeLocalGetItemsParamBean();
		}
		return userFacadeLocalGetItemsParamBean;
	}
	/** 
	 * @resultBean id=3
	 */
	public BidItemSDO[] getUserFacadeLocalGetItemsResultBean() {
		return userFacadeLocalGetItemsResultBean;
	}
	/** 
	 * @action id=3
	 */
	public String doUserFacadeLocalGetItemsAction() {
		try {
			userFacadeLocalGetItemsResultBean = getUserFacadeLocal().getItems(
					getUserFacadeLocalGetItemsParamBean().getSearchParam(),
					getUserFacadeLocalGetItemsParamBean().getMaxPrice(),
					getUserFacadeLocalGetItemsParamBean().getOrderbyIndex());
		} catch (Exception e) {
			logException(e);
		}
		return null;
	}
	/** 
	 * @paramBean id=4
	 */
	public UserFacadeLocalGetCategoryItemsParamBean getUserFacadeLocalGetCategoryItemsParamBean() {
		if (userFacadeLocalGetCategoryItemsParamBean == null) {
			userFacadeLocalGetCategoryItemsParamBean = new UserFacadeLocalGetCategoryItemsParamBean();
		}
		return userFacadeLocalGetCategoryItemsParamBean;
	}
	/** 
	 * @resultBean id=4
	 */
	public SellerItemSDO[] getUserFacadeLocalGetCategoryItemsResultBean() {
		return userFacadeLocalGetCategoryItemsResultBean;
	}
	/** 
	 * @action id=4
	 */
	public String doUserFacadeLocalGetCategoryItemsAction() {
		try {
			userFacadeLocalGetCategoryItemsResultBean = getUserFacadeLocal()
					.getCategoryItems(
							getUserFacadeLocalGetCategoryItemsParamBean()
									.getCategoryId());
		} catch (Exception e) {
			logException(e);
		}
		return null;
	}
	protected HtmlScriptCollector getScriptCollector1() {
		if (scriptCollector1 == null) {
			scriptCollector1 = (HtmlScriptCollector) findComponentInRoot("scriptCollector1");
		}
		return scriptCollector1;
	}
	protected HtmlForm getForm1() {
		if (form1 == null) {
			form1 = (HtmlForm) findComponentInRoot("form1");
		}
		return form1;
	}
	protected HtmlGraphicImageEx getImageEx1() {
		if (imageEx1 == null) {
			imageEx1 = (HtmlGraphicImageEx) findComponentInRoot("imageEx1");
		}
		return imageEx1;
	}
	protected HtmlPanelBox getBox4() {
		if (box4 == null) {
			box4 = (HtmlPanelBox) findComponentInRoot("box4");
		}
		return box4;
	}
	protected HtmlCommandLink getLink1() {
		if (link1 == null) {
			link1 = (HtmlCommandLink) findComponentInRoot("link1");
		}
		return link1;
	}
	
	protected HtmlForm getCatlistform() {
		if (catlistform == null) {
			catlistform = (HtmlForm) findComponentInRoot("catlistform");
		}
		return catlistform;
	}
	protected HtmlInputText getKeywords() {
		if (keywords == null) {
			keywords = (HtmlInputText) findComponentInRoot("keywords");
		}
		return keywords;
	}
	protected HtmlCommandExButton getButton2() {
		if (button2 == null) {
			button2 = (HtmlCommandExButton) findComponentInRoot("button2");
		}
		return button2;
	}
	protected HtmlDataTable getTable1() {
		if (table1 == null) {
			table1 = (HtmlDataTable) findComponentInRoot("table1");
		}
		return table1;
	}
	protected UIColumn getColumn1() {
		if (column1 == null) {
			column1 = (UIColumn) findComponentInRoot("column1");
		}
		return column1;
	}
	protected HtmlOutputText getTextCatHeader() {
		if (textCatHeader == null) {
			textCatHeader = (HtmlOutputText) findComponentInRoot("textCatHeader");
		}
		return textCatHeader;
	}
	protected HtmlOutputText getCatname() {
		if (catname == null) {
			catname = (HtmlOutputText) findComponentInRoot("catname");
		}
		return catname;
	}
	protected HtmlScriptCollector getScriptCollector2() {
		if (scriptCollector2 == null) {
			scriptCollector2 = (HtmlScriptCollector) findComponentInRoot("scriptCollector2");
		}
		return scriptCollector2;
	}
	protected HtmlDataTable getTable2() {
		if (table2 == null) {
			table2 = (HtmlDataTable) findComponentInRoot("table2");
		}
		return table2;
	}
	protected UIColumn getColumn5() {
		if (column5 == null) {
			column5 = (UIColumn) findComponentInRoot("column5");
		}
		return column5;
	}
	protected HtmlCommandExRowAction getRowAction1() {
		if (rowAction1 == null) {
			rowAction1 = (HtmlCommandExRowAction) findComponentInRoot("rowAction1");
		}
		return rowAction1;
	}
	protected HtmlPanelBox getBox3() {
		if (box3 == null) {
			box3 = (HtmlPanelBox) findComponentInRoot("box3");
		}
		return box3;
	}
	protected HtmlPagerDeluxe getDeluxe1() {
		if (deluxe1 == null) {
			deluxe1 = (HtmlPagerDeluxe) findComponentInRoot("deluxe1");
		}
		return deluxe1;
	}
	protected UIColumn getColumn10() {
		if (column10 == null) {
			column10 = (UIColumn) findComponentInRoot("column10");
		}
		return column10;
	}
	protected HtmlCommandExRowAction getRowAction2() {
		if (rowAction2 == null) {
			rowAction2 = (HtmlCommandExRowAction) findComponentInRoot("rowAction2");
		}
		return rowAction2;
	}
	protected HtmlPanelBox getBox2() {
		if (box2 == null) {
			box2 = (HtmlPanelBox) findComponentInRoot("box2");
		}
		return box2;
	}
	protected HtmlPagerDeluxe getDeluxe2() {
		if (deluxe2 == null) {
			deluxe2 = (HtmlPagerDeluxe) findComponentInRoot("deluxe2");
		}
		return deluxe2;
	}
	protected HtmlOutputText getTemplateWelcomeText() {
		if (templateWelcomeText == null) {
			templateWelcomeText = (HtmlOutputText) findComponentInRoot("templateWelcomeText");
		}
		return templateWelcomeText;
	}
	protected HtmlCommandLink getLink2() {
		if (link2 == null) {
			link2 = (HtmlCommandLink) findComponentInRoot("link2");
		}
		return link2;
	}
	protected HtmlPanelBox getBox1() {
		if (box1 == null) {
			box1 = (HtmlPanelBox) findComponentInRoot("box1");
		}
		return box1;
	}
	protected HtmlCommandLink getLink3() {
		if (link3 == null) {
			link3 = (HtmlCommandLink) findComponentInRoot("link3");
		}
		return link3;
	}
	protected HtmlCommandLink getLink4() {
		if (link4 == null) {
			link4 = (HtmlCommandLink) findComponentInRoot("link4");
		}
		return link4;
	}
	protected UINamingContainer getSubview1() {
		if (subview1 == null) {
			subview1 = (UINamingContainer) findComponentInRoot("subview1");
		}
		return subview1;
	}
	protected HtmlScriptCollector getScriptCollectorCat1() {
		if (scriptCollectorCat1 == null) {
			scriptCollectorCat1 = (HtmlScriptCollector) findComponentInRoot("scriptCollectorCat1");
		}
		return scriptCollectorCat1;
	}
	protected HtmlCommandLink getCatlistlink() {
		if (catlistlink == null) {
			catlistlink = (HtmlCommandLink) findComponentInRoot("catlistlink");
		}
		return catlistlink;
	}
	protected HtmlForm getForm2() {
		if (form2 == null) {
			form2 = (HtmlForm) findComponentInRoot("form2");
		}
		return form2;
	}
	protected UIColumn getColumn6() {
		if (column6 == null) {
			column6 = (UIColumn) findComponentInRoot("column6");
		}
		return column6;
	}
	protected HtmlOutputText getTitletext() {
		if (titletext == null) {
			titletext = (HtmlOutputText) findComponentInRoot("titletext");
		}
		return titletext;
	}
	protected UIColumn getColumn2() {
		if (column2 == null) {
			column2 = (UIColumn) findComponentInRoot("column2");
		}
		return column2;
	}
	protected HtmlOutputText getDesctext() {
		if (desctext == null) {
			desctext = (HtmlOutputText) findComponentInRoot("desctext");
		}
		return desctext;
	}
	protected UIColumn getColumn3() {
		if (column3 == null) {
			column3 = (UIColumn) findComponentInRoot("column3");
		}
		return column3;
	}
	protected HtmlGraphicImageEx getImage() {
		if (image == null) {
			image = (HtmlGraphicImageEx) findComponentInRoot("image");
		}
		return image;
	}
	protected UIColumn getColumn4() {
		if (column4 == null) {
			column4 = (UIColumn) findComponentInRoot("column4");
		}
		return column4;
	}
	protected HtmlOutputText getEndbidtext() {
		if (endbidtext == null) {
			endbidtext = (HtmlOutputText) findComponentInRoot("endbidtext");
		}
		return endbidtext;
	}
	protected HtmlDataTable getTable3() {
		if (table3 == null) {
			table3 = (HtmlDataTable) findComponentInRoot("table3");
		}
		return table3;
	}
	protected UIColumn getColumn7() {
		if (column7 == null) {
			column7 = (UIColumn) findComponentInRoot("column7");
		}
		return column7;
	}
	protected HtmlOutputText getTitletext2() {
		if (titletext2 == null) {
			titletext2 = (HtmlOutputText) findComponentInRoot("titletext2");
		}
		return titletext2;
	}
	protected UIColumn getColumn117() {
		if (column117 == null) {
			column117 = (UIColumn) findComponentInRoot("column117");
		}
		return column117;
	}
	protected HtmlOutputText getDesctext2() {
		if (desctext2 == null) {
			desctext2 = (HtmlOutputText) findComponentInRoot("desctext2");
		}
		return desctext2;
	}
	protected UIColumn getColumn8() {
		if (column8 == null) {
			column8 = (UIColumn) findComponentInRoot("column8");
		}
		return column8;
	}
	protected HtmlGraphicImageEx getImage101() {
		if (image101 == null) {
			image101 = (HtmlGraphicImageEx) findComponentInRoot("image101");
		}
		return image101;
	}
	protected UIColumn getColumn9() {
		if (column9 == null) {
			column9 = (UIColumn) findComponentInRoot("column9");
		}
		return column9;
	}
	protected HtmlOutputText getEndbidtext2() {
		if (endbidtext2 == null) {
			endbidtext2 = (HtmlOutputText) findComponentInRoot("endbidtext2");
		}
		return endbidtext2;
	}
	protected HtmlOutputText getText17() {
		if (text17 == null) {
			text17 = (HtmlOutputText) findComponentInRoot("text17");
		}
		return text17;
	}
	protected UIColumn getColumn12() {
		if (column12 == null) {
			column12 = (UIColumn) findComponentInRoot("column12");
		}
		return column12;
	}
	protected HtmlOutputText getValuetext2() {
		if (valuetext2 == null) {
			valuetext2 = (HtmlOutputText) findComponentInRoot("valuetext2");
		}
		return valuetext2;
	}

	protected UIColumn getColumn11() {
		if (column11 == null) {
			column11 = (UIColumn) findComponentInRoot("column11");
		}
		return column11;
	}
	protected HtmlOutputText getValuetext() {
		if (valuetext == null) {
			valuetext = (HtmlOutputText) findComponentInRoot("valuetext");
		}
		return valuetext;
	}
	protected HtmlOutputText getErrortext() {
		if (errortext == null) {
			errortext = (HtmlOutputText) findComponentInRoot("errortext");
		}
		return errortext;
	}
}