package pagecode;

import javax.ejb.CreateException;
import javax.faces.application.FacesMessage;
import javax.faces.component.html.HtmlInputSecret;
import javax.faces.component.html.HtmlInputText;

import sample.UserFacadeLocal;
import sample.UserFacadeLocalHome;
import sample.sdo.UserSDO;

import com.ibm.etools.service.locator.ServiceLocatorManager;

import com.ibm.faces.component.html.HtmlScriptCollector;
public class Login extends PageCodeBase {

	/** Page Code JSF UI Fields
	 * @pcElementClass tag
	 */
	protected HtmlScriptCollector scriptCollector1;
	/** Page Code JSF UI Fields
	 * @pcElementClass tag
	 */

	protected UserFacadeLocal userFacadeLocal;
	private final static String STATIC_UserFacadeLocalHome_REF_NAME = "ejb/UserFacade";
	private final static Class STATIC_UserFacadeLocalHome_CLASS = UserFacadeLocalHome.class;
	/** 
	 */
	protected UserFacadeLocalGetUserParamBean userFacadeLocalGetUserParamBean;
	/** 
	 */
	protected UserSDO userFacadeLocalGetUserResultBean;
	protected HtmlScriptCollector scriptCollector2;
	protected HtmlInputText usernametext;
	protected HtmlInputSecret userpassword;
	/** Page Code JSF UI Getters
	 * @pcElementClass tag
	 */
	protected HtmlScriptCollector getScriptCollector1() {
		if (scriptCollector1 == null) {
			scriptCollector1 = (HtmlScriptCollector) findComponentInRoot("scriptCollector1");
		}
		return scriptCollector1;
	}

	/** 
	 */
	public UserFacadeLocal createUserFacadeLocal() {

		UserFacadeLocalHome anUserFacadeLocalHome = (UserFacadeLocalHome) ServiceLocatorManager
				.getLocalHome(STATIC_UserFacadeLocalHome_REF_NAME,
						STATIC_UserFacadeLocalHome_CLASS);
		try {
			if (anUserFacadeLocalHome != null)
				return anUserFacadeLocalHome.create();
		} catch (CreateException ce) {
			ce.printStackTrace();
		}
		return null;
	}
	/** 
	 * @paramBean id=1
	 */
	public UserFacadeLocalGetUserParamBean getUserFacadeLocalGetUserParamBean() {
		if (userFacadeLocalGetUserParamBean == null) {
			userFacadeLocalGetUserParamBean = new UserFacadeLocalGetUserParamBean();
		}
		return userFacadeLocalGetUserParamBean;
	}
	/** 
	 * @resultBean id=1
	 */
	public UserSDO getUserFacadeLocalGetUserResultBean() {
		return userFacadeLocalGetUserResultBean;
	}
	/** 
	 * @action id=1
	 */
	public String doUserFacadeLocalGetUserAction() {
		try {
			userFacadeLocalGetUserResultBean = getUserFacadeLocal().getUser(
					getUserFacadeLocalGetUserParamBean().getEmail(),
					getUserFacadeLocalGetUserParamBean().getPassword());
					
					
			if(userFacadeLocalGetUserResultBean == null) {
			  // login failed
			  getFacesContext().addMessage(null, new FacesMessage("Login failed - enter correct userid and password"));
			  return "fail";
			}

			if(userFacadeLocalGetUserResultBean.getActive() == new Integer(0)) {
				// user is inactive
				getFacesContext().addMessage(null, new FacesMessage("Login failed - user is inactive"));
			    return "fail";
			} else {
			    // store the user object on the session
			    getSessionScope().put("currentuser", userFacadeLocalGetUserResultBean);
			    
			    String result = (String) getSessionScope().get("returntopage");
			    if(result == null) {
			    	result = "success";
			    }
			    
			    return result;
			}
		} catch (Exception e) {
			logException(e);
		}
		
		getFacesContext().addMessage(null, new FacesMessage("An error occured during login.  Check the log files."));
		
		return "fail";
	}
	/** Page Code Data Getters
	 * @pcElementClass data
	 */
	public void setUserFacadeLocal(UserFacadeLocal userFacadeLocal) {
		this.userFacadeLocal = userFacadeLocal;
	}
	/** Page Code Data Getters
	 * Page Code Data Getters
	 * @pcElementClass data
	 * @beanType EJB_Session_Bean
	 * @methodEntry id=getUser(java.lang.String,java.lang.String)/paramBean=1/resultBean=1/action=1
	 */
	public sample.UserFacadeLocal getUserFacadeLocal() {
		if (userFacadeLocal == null)
			userFacadeLocal = createUserFacadeLocal();
		return userFacadeLocal;
	}
	protected HtmlScriptCollector getScriptCollector2() {
		if (scriptCollector2 == null) {
			scriptCollector2 = (HtmlScriptCollector) findComponentInRoot("scriptCollector2");
		}
		return scriptCollector2;
	}
	protected HtmlInputText getUsernametext() {
		if (usernametext == null) {
			usernametext = (HtmlInputText) findComponentInRoot("usernametext");
		}
		return usernametext;
	}
	protected HtmlInputSecret getUserpassword() {
		if (userpassword == null) {
			userpassword = (HtmlInputSecret) findComponentInRoot("userpassword");
		}
		return userpassword;
	}
}