/**
 * AuctionListingsSOAPImpl.java
 *
 * This file was auto-generated from WSDL
 * by the IBM Web services WSDL2Java emitter.
 * o0444.10 v11404193627
 */

package org.tempuri;

import java.rmi.RemoteException;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;

import sample.AuctionSystemFacadeLocal;
import sample.AuctionSystemFacadeLocalHome;
import sample.ItemLocalHome;
import sample.UserFacadeLocal;
import sample.UserFacadeLocalHome;
import sample.sdo.CategorySDO;
import sample.sdo.CategorySDORoot;
import sample.sdo.SellerItemSDO;
import sample.sdo.SellerItemSDORoot;
import sample.sdo.StatusSDO;
import sample.sdo.UserSDO;
import sample.sdo.util.SdoClientFactory;

import com.ibm.etools.service.locator.ServiceLocatorManager;
import com.ibm.oiddemo.OIDGeneratorSessionLocal;
import com.ibm.oiddemo.OIDGeneratorSessionLocalHome;
import com.ibm.websphere.sbf.exceptions.CreateException;
import com.ibm.websphere.sbf.exceptions.DeleteException;
import com.ibm.websphere.sbf.exceptions.FindException;
import com.ibm.www.ItemType;
import com.ibm.www.ListedItemType;
import com.ibm.www.StatusType;

public class AuctionListingsSOAPImpl implements org.tempuri.AuctionListings_PortType
{
  private final static String STATIC_UserFacadeLocalHome_REF_NAME = "ejb/UserFacade";
  private final static Class STATIC_UserFacadeLocalHome_CLASS = UserFacadeLocalHome.class;
  private final static String STATIC_AuctionSystemFacadeLocalHome_REF_NAME = "ejb/AuctionSystemFacade";
  private final static Class STATIC_AuctionSystemFacadeLocalHome_CLASS = AuctionSystemFacadeLocalHome.class;
  private final static String STATIC_OIDGeneratorSessionLocalHome_REF_NAME = "ejb/OIDGeneratorSession";
  private final static Class STATIC_OIDGeneratorSessionLocalHome_CLASS = OIDGeneratorSessionLocalHome.class;

  public org.tempuri.AddItemResponse addItem(org.tempuri.AddItemRequest addItemRequest) throws java.rmi.RemoteException
  {
    UserFacadeLocal anUserFacadeLocal = createUserFacadeLocal();
    UserSDO userSDO;
    try
    {
      userSDO = anUserFacadeLocal.getUserSDOByKey(new Integer(addItemRequest.getUserId()));
    }
    catch (FindException fe)
    {
      throw new RemoteException(fe.getMessage(), fe);
    }
    OIDGeneratorSessionLocal anOIDGeneratorSessionLocal = createOIDGeneratorSessionLocal();
    Integer itemId = anOIDGeneratorSessionLocal.getNextOID(ItemLocalHome.ASN_NAME);
    SellerItemSDORoot itemSDORoot = SdoClientFactory.INSTANCE.createNewEmptySellerItemSDORoot();
    SellerItemSDO itemSDO = itemSDORoot.createSellerItemSDO();
    ItemType itemType = addItemRequest.getItem();
    
    CategorySDORoot categorySDORoot = SdoClientFactory.INSTANCE.createNewEmptyCategorySDORoot();
    CategorySDO categorySDO = categorySDORoot.createCategorySDO();
    categorySDO.setCatid(new Integer(itemType.getCategoryId()));
    itemSDO.setCategory(categorySDO);
    
    itemSDO.setItemid(itemId);
    itemSDO.setStartbidding(new Timestamp(itemType.getAuctionStartTime().getTime().getTime()));
    itemSDO.setEndbidding(new Timestamp(itemType.getAuctionEndTime().getTime().getTime()));    
    itemSDO.setCatalognumber(new Integer(itemType.getCategoryId()*1000+itemSDO.getItemid().intValue()));
    itemSDO.setDescription(itemType.getDescription());
    itemSDO.setImagepath(itemType.getImagePath());
    itemSDO.setImagesmallpath(itemType.getImageSmallPath());
    itemSDO.setStartingbid(new Integer(itemType.getStartingBid()));
    itemSDO.setTitle(itemType.getTitle());
    itemSDO.setValue(new Integer(itemType.getValue()));
    StatusSDO statusSDO = null;
    AuctionSystemFacadeLocal anAuctionSystemFacadeLocal = createAuctionSystemFacadeLocal();
    try
    {
      StatusSDO[] aStatusSDO = anAuctionSystemFacadeLocal.getAllStatusSDOObjects();
      if (aStatusSDO.length > 0)
        statusSDO = aStatusSDO[0];
    }
    catch (FindException ex)
    {
    }
    if (statusSDO == null)
    {
      statusSDO = itemSDORoot.createStatusSDO();
      statusSDO.setName("Available");
      statusSDO.setDescription("Available for bidding");
      try
      {
        anAuctionSystemFacadeLocal.createStatusSDO(statusSDO);
      }
      catch (CreateException ce)
      {
        throw new RemoteException(ce.getMessage(), ce);
      }
    }
    itemSDO.setFk_itemstatus(statusSDO);
    try
    {
      anUserFacadeLocal.createSellerItemSDO(itemSDO);
    }
    catch (CreateException ex)
    {
      throw new RemoteException(ex.getMessage(), ex);
    }
    
    AddItemResponse resp = new AddItemResponse();
    resp.setItemId(itemSDO.getItemid().intValue());
    return resp;
  }

  public org.tempuri.RemoveItemResponse removeItem(org.tempuri.RemoveItemRequest removeItemRequest) throws java.rmi.RemoteException
  {
    UserFacadeLocal anUserFacadeLocal = createUserFacadeLocal();
    SellerItemSDO itemSDO;
    RemoveItemResponse removeItemResponse = new RemoveItemResponse();
    try
    {
      int itemID = removeItemRequest.getItemId();
      itemSDO = anUserFacadeLocal.getSellerItemSDOByKey(new Integer(itemID));
      if (itemSDO != null) {
    	  anUserFacadeLocal.deleteSellerItemSDO(itemSDO);
    	  removeItemResponse.setResponseMessage("Item ID "+itemID+" removed");
      }
      else { 
    	  removeItemResponse.setResponseMessage("Failed to remove item.  Item ID "+itemID+" does not exist.");
      }
    }
    catch (FindException fe)
    {
      throw new RemoteException(fe.getMessage(), fe);
    }
    catch (DeleteException de)
    {
      throw new RemoteException(de.getMessage(), de);
    }
    return removeItemResponse;
  }

  public org.tempuri.ListItemResponse listItem(org.tempuri.ListItemRequest listItemRequest) throws java.rmi.RemoteException
  {
    UserFacadeLocal anUserFacadeLocal = createUserFacadeLocal();
    SellerItemSDO itemSDO;
    try
    {
      itemSDO = anUserFacadeLocal.getSellerItemSDOByKey(new Integer(listItemRequest.getItemId()));
    }
    catch (FindException fe)
    {
      throw new RemoteException(fe.getMessage(), fe);
    }
    ListedItemType listedItemType = createListedItemType(itemSDO);
    if (itemSDO != null) {
    	CategorySDO categorySDO = itemSDO.getCategory();
    	if (categorySDO != null) {
    		listedItemType.setCategoryId(categorySDO.getCatid().intValue());
    	}
    }
    ListItemResponse resp = new ListItemResponse();
    resp.setListedItem(listedItemType);
    return resp;
  }

  public com.ibm.www.ListedItemType[] listItems(org.tempuri.ListItemsRequest listItemsRequest) throws java.rmi.RemoteException
  {
    UserFacadeLocal anUserFacadeLocal = createUserFacadeLocal();
    SellerItemSDO[] itemSDOs = new SellerItemSDO[0];
    try
    {
      itemSDOs = anUserFacadeLocal.getAllSellerItemSDOObjects();
    }
    catch (FindException fe)
    {
      throw new RemoteException(fe.getMessage(), fe);
    }
    ListedItemType[] listedItemTypes = new ListedItemType[itemSDOs.length];
    for (int i = 0; i < listedItemTypes.length; i++)
      listedItemTypes[i] = createListedItemType(itemSDOs[i]);
    return listedItemTypes;
  }

  private ListedItemType createListedItemType(SellerItemSDO itemSDO)
  {
	  if (itemSDO == null) {
		  return null;
	  }
    ListedItemType listedItemType = new ListedItemType();
    CategorySDO categorySDO = itemSDO.getCategory();
    if (categorySDO != null) {
    	listedItemType.setCategoryId(categorySDO.getCatid().intValue());
    }
    Timestamp startBidding = itemSDO.getStartbidding();
    if (startBidding != null)
    {
      Calendar c = Calendar.getInstance();
      c.setTime(new Date(startBidding.getTime()));
      listedItemType.setAuctionStartTime(c);
    }
    Timestamp endBidding = itemSDO.getEndbidding();
    if (endBidding != null)
    {
      Calendar c = Calendar.getInstance();
      c.setTime(new Date(endBidding.getTime()));
      listedItemType.setAuctionEndTime(c);
    }
    listedItemType.setDescription(itemSDO.getDescription());
    listedItemType.setImagePath(itemSDO.getImagepath());
    listedItemType.setImageSmallPath(itemSDO.getImagesmallpath());
    Integer itemId = itemSDO.getItemid();
    listedItemType.setTitle(itemSDO.getTitle());
    if (itemId != null) 
    	listedItemType.setItemId(itemId.intValue());
    
    Integer startingBid = itemSDO.getStartingbid();
    if (startingBid != null)
      listedItemType.setStartingBid(startingBid.intValue());
    StatusSDO status = itemSDO.getFk_itemstatus();
    if (status != null)
    {
      StatusType statusType = new StatusType();
      statusType.setName(status.getName());
      statusType.setDescription(status.getDescription());
      listedItemType.setStatus(statusType);
    }
    Integer value = itemSDO.getValue();
    if (value != null)
      listedItemType.setValue(value.intValue());
    return listedItemType;
  }

  protected UserFacadeLocal createUserFacadeLocal()
  {
    UserFacadeLocalHome anUserFacadeLocalHome = (UserFacadeLocalHome)ServiceLocatorManager.getLocalHome(STATIC_UserFacadeLocalHome_REF_NAME, STATIC_UserFacadeLocalHome_CLASS);
    try
    {
      if (anUserFacadeLocalHome != null)
        return anUserFacadeLocalHome.create();
    }
    catch (javax.ejb.CreateException ce)
    {
      ce.printStackTrace();
    }
    return null;
  }

  protected AuctionSystemFacadeLocal createAuctionSystemFacadeLocal()
  {
    AuctionSystemFacadeLocalHome anAuctionSystemFacadeLocalHome = (AuctionSystemFacadeLocalHome)ServiceLocatorManager.getLocalHome(STATIC_AuctionSystemFacadeLocalHome_REF_NAME, STATIC_AuctionSystemFacadeLocalHome_CLASS);
    try
    {
      if (anAuctionSystemFacadeLocalHome != null)
        return anAuctionSystemFacadeLocalHome.create();
    }
    catch (javax.ejb.CreateException ce)
    {
      ce.printStackTrace();
    }
    return null;
  }

  protected OIDGeneratorSessionLocal createOIDGeneratorSessionLocal()
  {
    OIDGeneratorSessionLocalHome anOIDGeneratorSessionLocalHome = (OIDGeneratorSessionLocalHome)ServiceLocatorManager.getLocalHome(STATIC_OIDGeneratorSessionLocalHome_REF_NAME, STATIC_OIDGeneratorSessionLocalHome_CLASS);
    try
    {
      if (anOIDGeneratorSessionLocalHome != null)
        return anOIDGeneratorSessionLocalHome.create();
    }
    catch (javax.ejb.CreateException ce)
    {
      ce.printStackTrace();
    }
    return null;
  }
}